//==============================================================================
// TITLE: OpcBatchProps.h
//
// CONTENTS:
// 
// Defines property IDs for the Batch specifications.
//
// (c) Copyright 2000-2003 The OPC Foundation
// ALL RIGHTS RESERVED.
//
// DISCLAIMER:
//  This code is provided by the OPC Foundation solely to assist in 
//  understanding and use of the appropriate OPC Specification(s) and may be 
//  used as set forth in the License Grant section of the OPC Specification.
//  This code is provided as-is and without warranty or support of any sort
//  and is subject to the Warranty and Liability Disclaimers which appear
//  in the printed OPC Specification.
//
// MODIFICATION LOG:
//
// Date       By    Notes
// ---------- ---   -----
// 2000/01/17 OPC   Created.
// 2001/01/23 OPC   Added Version 2.0 properties.
// 2003/01/06 RSA   Updated formatting. 
//

#ifndef __OPCBATCHPROPS_H
#define __OPCBATCHPROPS_H

#define OPC_PROP_B_ID                           400
#define OPC_PROP_B_VALUE                        401
#define OPC_PROP_B_RIGHTS                       402
#define OPC_PROP_B_EU                           403
#define OPC_PROP_B_DESC                         404
#define OPC_PROP_B_HIGH_VALUE_LIMIT             405
#define OPC_PROP_B_LOW_VALUE_LIMIT              406
#define OPC_PROP_B_TIME_ZONE                    407
#define OPC_PROP_B_CONDITION_STATUS             408
#define OPC_PROP_B_PHYSICAL_MODEL_LEVEL         409
#define OPC_PROP_B_BATCH_MODEL_LEVEL            410
#define OPC_PROP_B_RELATED_BATCH_IDS            411
#define OPC_PROP_B_VERSION                      412
#define OPC_PROP_B_EQUIPMENT_CLASS              413
#define OPC_PROP_B_LOCATION                     414
#define OPC_PROP_B_MAXIMUM_USER_COUNT           415
#define OPC_PROP_B_CURRENT_USER_COUNT           416
#define OPC_PROP_B_CURRENT_USER_LIST            417
#define OPC_PROP_B_ALLOCATED_EQUIPMENT_LIST     418
#define OPC_PROP_B_REQUESTER_LIST               419
#define OPC_PROP_B_REQUESTED_LIST               420
#define OPC_PROP_B_SHARED_BY_LIST               421
#define OPC_PROP_B_EQUIPMENT_STATE              422
#define OPC_PROP_B_EQUIPMENT_MODE               423
#define OPC_PROP_B_UPSTREAM_EQUIPMENT_LIST      424
#define OPC_PROP_B_DOWNSTREAM_EQUIPMENT_LIST    425
#define OPC_PROP_B_EQUIPMENT_PROCEDURAL_ELEMENT_LIST   426
#define OPC_PROP_B_CURRENT_PROCEDURE_LIST       427
#define OPC_PROP_B_TRAIN_LIST                   428
#define OPC_PROP_B_DEVICE_DATA_SOURCE           429
#define OPC_PROP_B_DEVICE_DATA_SERVER           430
#define OPC_PROP_B_CAMPAIGN_ID                  431
#define OPC_PROP_B_LOT_ID_LIST                  432
#define OPC_PROP_B_CONTROL_RECIPE_ID            433
#define OPC_PROP_B_CONTROL_RECIPE_VERSION       434
#define OPC_PROP_B_MASTER_RECIPE_ID             435
#define OPC_PROP_B_MASTER_RECIPE_VERSION        436
#define OPC_PROP_B_PRODUCT_ID                   437
#define OPC_PROP_B_GRADE                        438
#define OPC_PROP_B_BATCH_SIZE                   439
#define OPC_PROP_B_PRIORITY                     440
#define OPC_PROP_B_EXECUTION_STATE              441
#define OPC_PROP_B_IEC61512_1_STATE             442
#define OPC_PROP_B_EXECUTION_MODE               443
#define OPC_PROP_B_IEC61512_1_MODE              444
#define OPC_PROP_B_SCHEDULED_START_TIME         445
#define OPC_PROP_B_ACTUAL_START_TIME            446
#define OPC_PROP_B_ESTIMATED_END_TIME           447
#define OPC_PROP_B_ACTUAL_END_TIME              448
#define OPC_PROP_B_PHYSICAL_MODEL_REFERENCE     449
#define OPC_PROP_B_EQUIPMENT_PROCEDURAL_ELEMENT 450
#define OPC_PROP_B_PARAMETER_COUNT              451
#define OPC_PROP_B_PARAMETER_TYPE               452
#define OPC_PROP_B_VALID_VALUES                 453
#define OPC_PROP_B_SCALING_RULE                 454
#define OPC_PROP_B_EXPRESSION_RULE              455
#define OPC_PROP_B_RESULT_COUNT                 456
#define OPC_PROP_B_ENUMERATION_SET_ID           457
//V2:Added 
#define OPC_PROP_B_MASTER_RECIPE_MODEL_LEVEL		458
#define OPC_PROP_B_PROCEDURE_LOGIC					459
#define OPC_PROP_B_PROCEDURE_LOGIC_SCHEMA			460
#define OPC_PROP_B_EQUIPMENT_CANDIDATE_LIST		461
#define OPC_PROP_B_EQUIPMENT_CLASS_CANDIDATE_LIST 462
#define OPC_PROP_B_VERSION_DATE						463
#define OPC_PROP_B_APPROVAL_DATE						464
#define OPC_PROP_B_EFFECTIVE_DATE					465
#define OPC_PROP_B_EXPIRATION_DATE					466
#define OPC_PROP_B_AUTHOR								467
#define OPC_PROP_B_APPROVED_BY						468
#define OPC_PROP_B_USAGE_CONSTRAINT					469
#define OPC_PROP_B_RECIPE_STATUS						470
#define OPC_PROP_B_RE_USE								471
#define OPC_PROP_B_DERIVED_RE							472
#define OPC_PROP_B_DERIVED_VERSION					473
#define OPC_PROP_B_SCALABLE							474
#define OPC_PROP_B_EXPECTED_DURATION				475
#define OPC_PROP_B_ACTUAL_DURATION					476
#define OPC_PROP_B_TRAIN_LIST2						477
#define OPC_PROP_B_TRAIN_LIST2_SCHEMA				478

#endif // __OPCBATCHPROPS_H