//http://www.rsdn.ru/forum/com/811910.hot
//http://forum.sources.ru/index.php?showtopic=54853
//http://msdn.microsoft.com/ru-ru/library/4c790ct9.aspx
//http://msdn.microsoft.com/ru-ru/magazine/cc500647.aspx
//http://www.rsdn.ru/article/com/comvs.xml
//http://kappasoft.narod.ru/info/com/rogerson/ch07.html
//http://www.rsdn.ru/forum/other/35774.hot
//http://www.rsdn.ru/forum/com/1986547.all
//http://www.rsdn.ru/forum/com/4885400.flat
//http://iprog.pp.ru/forum/read.php?f=1&i=68098&t=63611&v=f
//https://opcfoundation.org/developer-tools/developer-kits-classic/data-access-net-api-sample-code-and-applications/
//http://www.faweb.net/us/opc/sample_vc.html
//http://advosol.us/manuals/opcdanet/topic745.html
//http://www.tdoc.ru/c/cpp-sources/system/issleduem-set-wnetopenenum-wnetcloseenum.html
//http://msdn.microsoft.com/en-US/library/windows/desktop/aa385341(v=vs.85).aspx
//http://support.automation.siemens.com/WW/llisapi.dll?func=cslib.csinfo&objId=19237399&nodeid0=35771881&nav0=index&load=content&csSort=DOCDATUMBEITRAG&lang=en&siteid=cseus&aktprim=0&objaction=csview&extranet=standard&viewreg=WW
//http://lhcb-online.web.cern.ch/lhcb-online/ecs/opcevaluation/opcclienttutorial/SimpleClient.html
//http://www.cyberforum.ru/com-ole/thread792274.html
//http://forum.sources.ru/index.php?showtopic=145317
//http://read.pudn.com/downloads121/sourcecode/embed/515669/opcClientDlg/OPCClient/OPCServer.cpp__.htm
//http://www.ipi.ac.ru/lab43/lopc/faq-ru.html
//http://www.helloworld.ru/texts/comp/lang/visualc/vc2/25.htm
//http://www.clipepper.zxscript.com/OPC/OPC%20HDA%20Auto%201.00%20Sample%20Code/Automation%20Wrapper/OPCHDAAutoServer.cpp
//https://github.com/jiajw0426/easyscada/blob/master/drivers/opc_client_hda/protocol/opcclient_hda.cpp
//https://code.google.com/p/bingo-file-search/


//http://demin.ws/blog/russian/2009/02/23/static-code-analysis-coverity-klocwork/

#include "my_opc.h"
#include <comdef.h>
#include "c:\proekts\my_opc\my_opc\inc\opcda_i.c"
#include "c:\proekts\my_opc\my_opc\inc\OpcEnum_i.c"
#include "c:\proekts\my_opc\my_opc\inc\opccomn_i.c"
#include "c:\proekts\my_opc\my_opc\inc\opchda_i.c"

#define MAX_NET_RESOURCES (1024)
QString current_opc_server_name,temp_str;

my_opc::my_opc(QWidget *parent, Qt::WFlags flags)
	: QMainWindow(parent, flags)
{
	ui.setupUi(this);

	QApplication::setStyle(new QWindowsXPStyle);

	ui.tableWidget_2->verticalHeader()->hide();

	QByteArray mystate;
	QByteArray mygeom;
	uchar geo_size;

	QFile file("size.dat");

	if (file.open(QFile::ReadOnly))
	{
		bool ok = file.getChar((char*)&geo_size);
		if (ok) 
		{
			mygeom=file.read(geo_size);
			mystate=file.readAll();
			file.close();
			QRect my_rect = QApplication::desktop()->availableGeometry(0);
			this->resize(my_rect.size());
			restoreGeometry(mygeom);
			restoreState(mystate);
		}
	}

	ui.VendorInfo->clear();
	ui.ftCurrentTime->clear();
	ui.s_version->clear();
	ui.wBuildNumber->clear();
	ui.my_guid->clear();

	ui.tableWidget->horizontalHeader()->setHighlightSections(false);
	ui.tableWidget->hideColumn(6);
	ui.tableWidget_2->horizontalHeader()->setHighlightSections(false);
	ui.tableWidget_3->horizontalHeader()->setHighlightSections(false);

	enum_network(NULL); //   ( )
	connect(ui.treeWidget, SIGNAL(itemExpanded(QTreeWidgetItem*)), this, SLOT(onitemExpanded(QTreeWidgetItem*)));
	connect(ui.treeWidget, SIGNAL(currentItemChanged( QTreeWidgetItem *, QTreeWidgetItem *)), this, SLOT(indexChanged(QTreeWidgetItem *, QTreeWidgetItem *)));
	connect(ui.ReadRawButton, SIGNAL(clicked()), this, SLOT(do_ReadRawButton()));
	connect(ui.ReadAtTimeButton, SIGNAL(clicked()), this, SLOT(do_ReadAtTimeButton()));
	connect(ui.ReadAttributeButton, SIGNAL(clicked()), this, SLOT(do_ReadAttributeButton()));
	connect(ui.ReadProcessedButton, SIGNAL(clicked()), this, SLOT(do_ReadProcessedButton()));
	
	QDateTime now = QDateTime::currentDateTime();	
	ui.dateTimeEdit->setCalendarPopup(true);
	ui.dateTimeEdit_2->setCalendarPopup(true);
	ui.dateTimeEdit->calendarWidget()->setFirstDayOfWeek(Qt::Monday);
	ui.dateTimeEdit_2->calendarWidget()->setFirstDayOfWeek(Qt::Monday);
	ui.dateTimeEdit->setDateTime(now);
	ui.dateTimeEdit_2->setDateTime(now);
	
	HRESULT hr = CoInitialize(NULL);
	if (!SUCCEEDED(hr))
	{
		QMessageBox::warning(this, tr(""), "  COM");
		return;
	}

	id = 0;
	p_da_Browser = NULL;
	m_opcServer = NULL;
	p_hda_Browser = NULL;
	m_hda_opcServer = NULL;

	update_timer = new QTimer;
	connect (update_timer, SIGNAL (timeout ()), this, SLOT (update_opc_items()));	
}

my_opc::~my_opc()
{
	HRESULT *pErrors;
	for (int i=0; i<run_servers.count();i++)
	{
		IOPCItemMgt *pGRP;
		HRESULT hr = run_servers[i].opcServer->GetGroupByName(_T("MyGroup"), __uuidof(IOPCItemMgt), (IUnknown**)&pGRP);
		if (SUCCEEDED(hr))
		{
			IEnumOPCItemAttributes * pEnum;		
			hr = pGRP->CreateEnumerator(IID_IEnumOPCItemAttributes, (IUnknown **)&pEnum);
			if (hr == S_OK)
			{
				HRESULT r2 = S_OK;
				OPCITEMATTRIBUTES *pIA;
				ULONG actual;
				while ((r2 = pEnum->Next(1, &pIA, &actual)) == S_OK)
					HRESULT hr1 = pGRP->RemoveItems(1, &pIA->hServer, &pErrors);
			}
				
			for (int j = 0; j < hwnds.count(); j++)
			{
				   if (hwnds[j].ItemMgt == pGRP)
				{
					hr = run_servers[i].opcServer->RemoveGroup(hwnds[j].add_grp_handle,true);
					hwnds[j].syncio->Release();
					hwnds[j].syncio = NULL;
					hwnds[j].ItemMgt->Release();
					hwnds[j].ItemMgt = NULL;
					break;
				}				   
			}						
		}
		 run_servers[i].opcServer.Release();
		 run_servers[i].opcServer = NULL;

		 run_servers[i].cur_browse_item->Release();
		 run_servers[i].cur_browse_item = NULL;
	}

	hwnds.clear();
	run_servers.clear();

	for (int i = 0;i<hda_run_servers.count();i++)
	{
		hda_run_servers[i].hda_opcServer.Release();
		hda_run_servers[i].hda_opcServer = NULL;
	}
	hda_run_servers.clear();

	if (p_da_Browser != NULL)
	{
		p_da_Browser->Release();
		p_da_Browser = NULL;
	}
	
	if (m_opcServer != NULL)
	{
		m_opcServer.Release();
		m_opcServer = NULL;
	}

	if (p_hda_Browser != NULL)
	{
		p_hda_Browser->Release();
		p_hda_Browser = NULL;
	}

	if (m_hda_opcServer != NULL)
	{
		m_hda_opcServer.Release();
		m_hda_opcServer = NULL;
	}

	CoUninitialize();	
}

QString my_opc::get_quality(ushort usQuality)
{
	QString quality = "Unknown";
	switch (usQuality)
	{
	case 0x00: quality =  "Bad"; break;
	case 0x04: quality =  "Config Error"; break;
	case 0x08: quality =  "Not Connected"; break;
	case 0x0C: quality =  "Device Failure"; break;
	case 0x10: quality =  "Sensor Failure"; break;
	case 0x14: quality =  "Last Known"; break;
	case 0x18: quality =  "Comm Failure"; break;
	case 0x1C: quality =  "Out of Service"; break;
	case 0x20: quality =  "Initializing"; break;
	case 0x40: quality =  "Uncertain"; break;
	case 0x44: quality =  "Last Usable"; break;
	case 0x50: quality =  "Sensor Calibration"; break;
	case 0x54: quality =  "EGU Exceeded"; break;
	case 0x58: quality =  "Sub Normal"; break;
	case 0xC0: quality =  "Good"; break;
	case 0xD8: quality =  "Local Override"; break;
	default: quality =  "Unknown";
	}
	return quality;
}

QString my_opc::get_hda_quality(DWORD qualit)
{
	QString quality = "Unknown";
	WORD hi = HIWORD(qualit);
	ushort lo  = LOWORD(qualit);
	switch ( hi)
	{
	case 0x0001: {
					quality =  "OPCHDA_EXTRADATA"; 
					break;
				 }
	case 0x0002: {
					quality =  "OPCHDA_INTERPOLATED"; 					
					break;
				 }
	case 0x0004: {
					quality =  "OPCHDA_RAW"; 
					quality = quality+", "+get_quality(lo);
					break;
				 }
	case 0x0008: {
					quality =  "OPCHDA_CALCULATED"; 
					break;
				 }
	case 0x0010: {
					quality =  "OPCHDA_NOBOUND"; 
					quality = quality+", "+get_quality(lo);
					break;
				 }
	case 0x0020: {
					quality =  "OPCHDA_NODATA";
					quality = quality+", "+get_quality(lo);
					break;
				 }
	case 0x0040: {
					quality =  "OPCHDA_DATALOST";
					quality = quality+", "+get_quality(lo);
					break;
				 }
	case 0x0080: {
					quality =  "OPCHDA_CONVERSION";
					quality = quality+", "+get_quality(lo);
					break;
				 }
	case 0x0100: {
					quality =  "OPCHDA_PARTIAL";
					quality = quality+", "+get_quality(lo);
					break;
				 }
	default: quality =  "Unknown";
	}
	return quality;
}

OPCHDA_TIME my_opc::getstarttime()
{
	OPCHDA_TIME opcStartTime;
	memset(&opcStartTime, 0, sizeof(opcStartTime));	
	opcStartTime.bString = false;
	SYSTEMTIME st_begin;

	st_begin.wYear = ui.dateTimeEdit->date().year();
	st_begin.wMonth = ui.dateTimeEdit->date().month();
	st_begin.wDayOfWeek = ui.dateTimeEdit->date().dayOfWeek();
	st_begin.wDay = ui.dateTimeEdit->date().day();
	st_begin.wHour = ui.dateTimeEdit->time().hour();
	st_begin.wMinute = ui.dateTimeEdit->time().minute();
	st_begin.wSecond = ui.dateTimeEdit->time().second();
	st_begin.wMilliseconds = ui.dateTimeEdit->time().msec();
	SystemTimeToFileTime(&st_begin,&opcStartTime.ftTime);
	return opcStartTime;
}

OPCHDA_TIME my_opc::getendtime()
{
	OPCHDA_TIME opcEndTime;
	memset(&opcEndTime, 0, sizeof(opcEndTime));
	opcEndTime.bString = false;
	SYSTEMTIME st_end;

	st_end.wYear = ui.dateTimeEdit_2->date().year();
	st_end.wMonth = ui.dateTimeEdit_2->date().month();
	st_end.wDayOfWeek = ui.dateTimeEdit_2->date().dayOfWeek();
	st_end.wDay = ui.dateTimeEdit_2->date().day();
	st_end.wHour = ui.dateTimeEdit_2->time().hour();
	st_end.wMinute = ui.dateTimeEdit_2->time().minute();
	st_end.wSecond = ui.dateTimeEdit_2->time().second();
	st_end.wMilliseconds = ui.dateTimeEdit_2->time().msec();
	SystemTimeToFileTime(&st_end,&opcEndTime.ftTime);
	return opcEndTime;
}


void my_opc::update_opc_items()
{
	ui.tableWidget->setRowCount(0);
	for (int i=0; i<hwnds.count();i++)
	{
		tagOPCITEMSTATE *pItemValue = NULL;
		HRESULT* pErrors = NULL;
		HRESULT hr = hwnds[i].syncio->Read(OPC_DS_CACHE,1, hwnds[i].srv_results, &pItemValue,&pErrors); // 
		if (SUCCEEDED(hr))
		{
			temp_str  = "";
			QStringList items = get_value(&pItemValue->vDataValue);
			ui.tableWidget->insertRow(0);

			QTableWidgetItem *server_name = new QTableWidgetItem();
			server_name->setData(0,hwnds[i].server_name);
			ui.tableWidget->setItem(0, 0, server_name);

			QTableWidgetItem *name_item = new QTableWidgetItem();
			name_item->setData(0, hwnds[i].itemID);
			ui.tableWidget->setItem(0, 1, name_item);

			QTableWidgetItem *value_item = new QTableWidgetItem();
			value_item->setData(0,items[0]);
			ui.tableWidget->setItem(0, 2, value_item);

			FILETIME tag_time = pItemValue->ftTimeStamp;
			SYSTEMTIME st;
			FileTimeToLocalFileTime(&tag_time, &tag_time);

			QString tagtime;
				if (FileTimeToSystemTime(&tag_time, &st))
					tagtime = SystemTime_to_QString(st);
				else
					tagtime = "";

			
			QTableWidgetItem *time_item = new QTableWidgetItem();
			time_item->setData(0,tagtime);
			ui.tableWidget->setItem(0, 3, time_item);
			
			QString quality = get_quality(pItemValue->wQuality);
			
			QTableWidgetItem *quality_item = new QTableWidgetItem();
			quality_item->setData(0,quality);
			ui.tableWidget->setItem(0, 4, quality_item);

			QTableWidgetItem *type_item = new QTableWidgetItem();
			type_item->setData(0,items[1]);
			ui.tableWidget->setItem(0, 5, type_item);																		

			QTableWidgetItem *id_item = new QTableWidgetItem();
			id_item->setData(0,hwnds[i].myId);
			ui.tableWidget->setItem(0, 6, id_item);
		}
		CoTaskMemFree(pItemValue);
		CoTaskMemFree(pErrors);
		ui.tableWidget->resizeRowsToContents();
		ui.tableWidget->resizeColumnsToContents();
	}	
}

void my_opc::do_ReadRawButton()
{
	ui.dateTimeEdit->setDisabled(false);
	ui.dateTimeEdit_2->setDisabled(false);
	ui.Processed_comboBox->setDisabled(true);
	ui.Attribute_comboBox->setDisabled(true);
	ui.ResampleInterval->setDisabled(true);
}

void my_opc::do_ReadAtTimeButton()
{
	ui.dateTimeEdit->setDisabled(false);
	ui.dateTimeEdit_2->setDisabled(true);
	ui.Processed_comboBox->setDisabled(true);
	ui.Attribute_comboBox->setDisabled(true);
	ui.ResampleInterval->setDisabled(true);
}

void my_opc::do_ReadAttributeButton()
{
	ui.dateTimeEdit->setDisabled(false);
	ui.dateTimeEdit_2->setDisabled(false);
	ui.Processed_comboBox->setDisabled(true);
	ui.Attribute_comboBox->setDisabled(false);
	ui.ResampleInterval->setDisabled(true);
	ui.Attribute_comboBox->clear();

	if (m_hda_opcServer != NULL)
			{
				
				ui.tableWidget_2->setColumnCount(3);
				ui.tableWidget_2->setRowCount(0);
				ui.tableWidget_2->setSortingEnabled(false);

				DWORD dwCount = 0;
				DWORD* pdwAttrID = NULL;
				LPWSTR* pAttrName = NULL;
				LPWSTR* pAttrDesc = NULL;

				VARTYPE *vts = 0;
				HRESULT hr = m_hda_opcServer->GetItemAttributes(&dwCount, &pdwAttrID, &pAttrName, &pAttrDesc, &vts);
				if (SUCCEEDED(hr))
				{
					for (int i=0;i<dwCount;i++)
					{
						ui.tableWidget_2->insertRow(0);						
						DWORD agrid = pdwAttrID[i];
						QTableWidgetItem *number_item = new QTableWidgetItem();
						number_item->setData(0, (qint64) agrid);
						ui.tableWidget_2->setItem(0, 0, number_item);

						QString item_name = QString::fromStdWString(pAttrName[i]);
						QTableWidgetItem *descr_item = new QTableWidgetItem();
						descr_item->setData(0,item_name);
						ui.tableWidget_2->setItem(0, 1, descr_item);

						QString item_desc = QString::fromStdWString(pAttrDesc[i]);
						QTableWidgetItem *value_item = new QTableWidgetItem();
						value_item->setData(0,item_desc);
						ui.tableWidget_2->setItem(0, 2, value_item);
						ui.Attribute_comboBox->addItem(QString::number(agrid));
					}
				}
				ui.tableWidget_2->setSortingEnabled(true);
				ui.tableWidget_2->sortItems(0);
			}
}

void my_opc::do_ReadProcessedButton()
{
	
	ui.dateTimeEdit->setDisabled(false);
	ui.dateTimeEdit_2->setDisabled(false);
	ui.Processed_comboBox->setDisabled(false);
	ui.Attribute_comboBox->setDisabled(true);
	ui.ResampleInterval->setDisabled(false);
	ui.Processed_comboBox->clear();
	
	if (m_hda_opcServer != NULL)
			{
				ui.tableWidget_2->setColumnCount(3);
				ui.tableWidget_2->setRowCount(0);
				ui.tableWidget_2->setSortingEnabled(false);

				DWORD dwCount = 0;
				DWORD* pdwAggrID = NULL;
				LPWSTR* pAggrName = NULL;
				LPWSTR* pAggrDesc = NULL;

				HRESULT hr = m_hda_opcServer->GetAggregates(&dwCount,&pdwAggrID,&pAggrName,&pAggrDesc);
				if (SUCCEEDED(hr))
				{
					for (int i=0;i<dwCount;i++)
					{						
						ui.tableWidget_2->insertRow(0);						
						DWORD agrid = pdwAggrID[i];
						QTableWidgetItem *number_item = new QTableWidgetItem();
						number_item->setData(0, (qint64) agrid);
						ui.tableWidget_2->setItem(0, 0, number_item);

						QString item_name = QString::fromStdWString(pAggrName[i]);
						QTableWidgetItem *descr_item = new QTableWidgetItem();
						descr_item->setData(0,item_name);
						ui.tableWidget_2->setItem(0, 1, descr_item);

						QString item_desc = QString::fromStdWString(pAggrDesc[i]);
						QTableWidgetItem *value_item = new QTableWidgetItem();
						value_item->setData(0,item_desc);
						ui.tableWidget_2->setItem(0, 2, value_item);
						ui.Processed_comboBox->addItem(QString::number(agrid));
					}
				}
				ui.tableWidget_2->setSortingEnabled(true);
				ui.tableWidget_2->sortItems(0);
			}
}

void my_opc::returnToOldMaxMinSizes()
{
	ui.dockWidget_5->setMinimumSize(0,0);
	ui.dockWidget_5->setMaximumSize(524287,524287);	
}


void my_opc::setDockSize(QDockWidget* dock, int setWidth,int setHeight)
{
	if (setWidth>=0)
		if (dock->width()<setWidth)
			dock->setMinimumWidth(setWidth);
		else dock->setMaximumWidth(setWidth);
		if (setHeight>=0)
			if (dock->height()<setHeight)
				dock->setMinimumHeight(setHeight);
			else dock->setMaximumHeight(setHeight);
		
			QTimer::singleShot(1, this, SLOT(returnToOldMaxMinSizes()));
}

void my_opc::resizeEvent(QResizeEvent *event)
{
	int delta;
	delta = this->width() - ui.dockWidget->width()-10;
	setDockSize(ui.dockWidget_5, delta, ui.dockWidget_5->height());
	QMainWindow::resizeEvent(event);
}

void my_opc::closeEvent(QCloseEvent *event)
{
	QByteArray mygeom = saveGeometry();
	QByteArray mystate = saveState();

	QFile file("size.dat");
	if (!file.open(QFile::WriteOnly)) 
	{
		QString msg = file.errorString();
		QMessageBox::warning(this, tr(""), msg);	
	} 
	else
	{
		file.putChar((uchar)mygeom.size());
		file.write(mygeom);
		file.write(mystate);
		file.close();
	}

}

QTextDocument *my_opc::print_opc_info(QTableWidget *tbl)
{
	QTextDocument *document = new QTextDocument;
	QTextCursor cursor(document);
	int column_count = 0;

	if (tbl->rowCount() == 0) 
		return document;

	QSplashScreen splash(QPixmap(":/png/splash.png")); 
	splash.setWindowModality(Qt::ApplicationModal);
	splash.show();
	splash.showMessage(" ...",Qt::AlignBottom);	

	QStringList mycolumns;
	if (tbl->objectName()=="tableWidget")
	{
    mycolumns<<""<<"ID"<<""<<""<<""<<" ";
	column_count = 6;
	}
	else
		if (tbl->objectName() == "tableWidget_3")
		{
			mycolumns<<""<<""<<" "<<"";
			column_count = 4;
		}

	QModelIndexList currentSelection = tbl->selectionModel()->selectedRows();
	if (currentSelection.count()==0)
	{
	    tbl->selectAll();
		currentSelection = tbl->selectionModel()->selectedRows();
	}

	qSort(currentSelection.begin(),currentSelection.end(),qGreater<QModelIndex>());
	QModelIndex index;

	QTextTable *table = cursor.insertTable(currentSelection.count()+1,mycolumns.count());
	for (int i=0;i<mycolumns.count();i++)
		table->cellAt(0,i).firstCursorPosition().insertText(mycolumns.at(i));

	int rows = 1;
	if (currentSelection.count()!=0)
	{		
		foreach(index, currentSelection) 
		{
			for (int j = 0; j < column_count; j++)
			{
				QString data = tbl->item(index.row(),j)->data(2).toString();
				table->cellAt(rows,j).firstCursorPosition().insertText(data);
			}
			rows++;
		}
	}
	return document;
}


void my_opc::DisplayChildren(QTreeWidgetItem *current)
{
	IEnumString *pEnum;
	LPOLESTR str_name = 0;   
	ulong cn = 0;
    LPWSTR lpItemID;
	QString item_path = "";
	HRESULT res;

	res = p_da_Browser->BrowseOPCItemIDs(OPC_LEAF,L"*",VT_EMPTY, 0, &pEnum); //   -  
	if (res == S_OK)
 {
	while (pEnum->Next(1, &str_name, &cn) == S_OK)
	{						
		HRESULT hr = p_da_Browser->GetItemID(str_name, &lpItemID);
		if (SUCCEEDED(hr))		
			item_path = QString::fromStdWString(lpItemID);			
		else
		{
			QString err = QString::fromUtf16(_com_error(hr).ErrorMessage());
			QMessageBox::warning(0, "!","GetItemID  : "+err);

			QString parents_name = "";
			QTreeWidgetItem *item = current;

			while (item->parent())
			{
				item = item->parent();
				parents_name = item->text(0)+"."+parents_name; //      ?????
			}

			parents_name = parents_name+current->text(0)+"."+QString::fromStdWString(str_name);
			int position = parents_name.indexOf(current_opc_server_name);
			parents_name.remove(0, position+current_opc_server_name.size()+1);			
			item_path = parents_name;
		}

		QTreeWidgetItem *item = new QTreeWidgetItem;
		item->setText(0, QString::fromStdWString(str_name));
		QStringList item_data;
		item_data<<"OPC_VALUE"<<item_path<<"";
		item->setData(0, Qt::UserRole, item_data);
		current->addChild(item);		
	}
 }

	res = p_da_Browser->BrowseOPCItemIDs(OPC_BRANCH,L"*",VT_EMPTY, 0, &pEnum); // 
	if (res == S_OK)
 {
	while (pEnum->Next(1, &str_name, &cn) == S_OK)
	{		
		HRESULT hr = p_da_Browser->GetItemID(str_name, &lpItemID);		
		if (SUCCEEDED(hr))
			item_path = QString::fromStdWString(lpItemID);
		else
		{
			QString err = QString::fromUtf16(_com_error(hr).ErrorMessage());
			QMessageBox::warning(0, "!","GetItemID  : "+err);

			QString parents_name = "";
			QTreeWidgetItem *item = current;

			while (item->parent())
			{
				item = item->parent();
				parents_name = item->text(0)+"."+parents_name; //      ?????
			}

			parents_name = parents_name+current->text(0)+"."+QString::fromStdWString(str_name);
			int position = parents_name.indexOf(current_opc_server_name);
			parents_name.remove(0, position+current_opc_server_name.size()+1);			
			item_path = parents_name;
		}

		QTreeWidgetItem *item = new QTreeWidgetItem;
		item->setText(0, QString::fromStdWString(str_name));

		QStringList item_data;
		item_data<<"OPC_BRANCH"<<item_path<<"";
		item->setData(0, Qt::UserRole, item_data);
		item->setChildIndicatorPolicy(QTreeWidgetItem::ShowIndicator);

		current->addChild(item);

		//HRESULT hres = pParent->ChangeBrowsePosition(OPC_BROWSE_DOWN, str_name);
		//if (SUCCEEDED(hres))			
			//DisplayChildren(item);
		
		//pParent->ChangeBrowsePosition(OPC_BROWSE_UP, L"\0");
	}
 }
	ui.treeWidget->resizeColumnToContents(0);
}

void my_opc::Display_HDA_Children(QTreeWidgetItem *current)
{
	IEnumString *pEnum;
	LPOLESTR str_name = 0; 
	ulong cn = 0;
	LPWSTR lpItemID;
	QString item_path = "";
	HRESULT res;

	res = p_hda_Browser->GetEnum(OPCHDA_LEAF,&pEnum);
	if (res == S_OK)
 {
	while (pEnum->Next(1, &str_name, &cn) == S_OK)
	{
		HRESULT hr = p_hda_Browser->GetItemID(str_name, &lpItemID);
		if (SUCCEEDED(hr))		
			item_path = QString::fromStdWString(lpItemID);	
		else
		{
		QString err = QString::fromUtf16(_com_error(hr).ErrorMessage());
		QMessageBox::warning(0, "!","GetItemID  : "+err);
		return;
		}

		QTreeWidgetItem *item = new QTreeWidgetItem;
		item->setText(0, QString::fromStdWString(str_name));
		QStringList item_data;
		item_data<<"OPC_VALUE"<<item_path<<"";
		item->setData(0, Qt::UserRole, item_data);
		current->addChild(item);		
	}
 }
	res = p_hda_Browser->GetEnum(OPCHDA_BRANCH,&pEnum);
	if (res == S_OK)
 {
	while (pEnum->Next(1, &str_name, &cn) == S_OK)
	{
		HRESULT hr = p_hda_Browser->GetItemID(str_name, &lpItemID);
		if (SUCCEEDED(hr))		
			item_path = QString::fromStdWString(lpItemID);
		else
		{
			QString err = QString::fromUtf16(_com_error(hr).ErrorMessage());
			QMessageBox::warning(0, "!","GetItemID  : "+err);
			return;
		}
		QTreeWidgetItem *item = new QTreeWidgetItem;
		item->setText(0, QString::fromStdWString(str_name));
		QStringList item_data;
		item_data<<"OPCHDA_BRANCH"<<item_path<<"";
		item->setData(0, Qt::UserRole, item_data);
		item->setChildIndicatorPolicy(QTreeWidgetItem::ShowIndicator);
		current->addChild(item);
	}
 }

}

void my_opc::get_opcserver_status(const QString &guid)
{
	OPCSERVERSTATUS *ppstatus;
	HRESULT hres = m_opcServer->GetStatus(&ppstatus);
	if (hres == S_OK)
	{														
		QString vendor_info = QString::fromStdWString(ppstatus->szVendorInfo);							
		ui.VendorInfo->setText(vendor_info);							
		FILETIME start_time = ppstatus->ftCurrentTime;		
		SYSTEMTIME st;
		FileTimeToLocalFileTime(&start_time, &start_time);

		QString curr_time;
		if (FileTimeToSystemTime(&start_time, &st))
			curr_time = SystemTime_to_QString(st);
		else
			curr_time = "";
			
		ui.ftCurrentTime->setText(curr_time);
		QString ver = QString::number(ppstatus->wMajorVersion)+"."+QString::number(ppstatus->wMinorVersion);
		ui.s_version->setText(ver);
		ui.wBuildNumber->setText(QString::number(ppstatus->wBuildNumber));
		ui.my_guid->setText(guid);

		CoTaskMemFree(ppstatus->szVendorInfo);
		CoTaskMemFree(ppstatus);							
	}
}

void my_opc::get_hda_opcserver_status(const QString &guid)
{
	OPCHDA_SERVERSTATUS pStatus;
	FILETIME *pftCurrentTime = NULL;
	FILETIME *pftStartTime = NULL;
	WORD				pwMajorVersion;
	WORD				pwMinorVersion;
	WORD				pwBuildNumber;
	DWORD				pdwMaxReturnValues;
	LPWSTR				ppszStatusString;
	LPWSTR				ppszVendorInfo;

	HRESULT hr = m_hda_opcServer->GetHistorianStatus(&pStatus, &pftCurrentTime, &pftStartTime, &pwMajorVersion, &pwMinorVersion,&pwBuildNumber, &pdwMaxReturnValues, &ppszStatusString, &ppszVendorInfo);
	if (SUCCEEDED(hr))
	{
		QString vendor_info = QString::fromStdWString(ppszVendorInfo);
		ui.VendorInfo->setText(vendor_info);							
		SYSTEMTIME st;
		QString curr_time;
		FileTimeToLocalFileTime(pftCurrentTime, pftCurrentTime);
		if (FileTimeToSystemTime(pftCurrentTime, &st))
			curr_time = SystemTime_to_QString(st);
		else
			curr_time = "";
		ui.ftCurrentTime->setText(curr_time);
		QString ver = QString::number(pwMajorVersion)+"."+QString::number(pwMinorVersion);
		ui.s_version->setText(ver);
		ui.wBuildNumber->setText(QString::number(pwBuildNumber));
		ui.my_guid->setText(guid);
	}
}

void my_opc::onitemExpanded(QTreeWidgetItem *current)
{
	if (current)
	{		
		QStringList itm_data = current->data(0,Qt::UserRole).toStringList();
		if (itm_data.size() == 8)
		{			
			if (itm_data[2].toULong() == RESOURCEDISPLAYTYPE_SERVER ) //1.   -   da, hda 
			{
				QSplashScreen splash(QPixmap(":/png/splash.png")); 
				splash.move(QCursor::pos());
				splash.show();
				splash.showMessage("...", Qt::AlignBottom);		 

				current->takeChildren();
				get_OPCServerList(current, CATID_OPCDAServer20);
				get_OPCServerList(current, CATID_OPCHDAServer10);			
				return;
			}
		}
		else
			if (itm_data.size() == 3)
			{
				if (itm_data[0] == "OPC_DA_SERVER_NAME") //2.   da  -   
				{
					if (m_opcServer != NULL)
						m_opcServer.Release(); //?????

					QUuid myguid(itm_data[2]);

					for (int i = 0; i<run_servers.count();i++)
					{
						if (run_servers[i].server_name == itm_data[1] && run_servers[i].guid == myguid)	//     	
							{									  							 
							  m_opcServer = run_servers[i].opcServer;
							  p_da_Browser = run_servers[i].cur_browse_item;
							  current->takeChildren();
							  DisplayChildren(current);	
							  get_opcserver_status(itm_data[2]);
							  ui.toolButton->setEnabled(true);
							  return;
						    }
					}
									
					QString comp_name = itm_data[1];
					COSERVERINFO *ServerInfo = new COSERVERINFO();
					ServerInfo->pwszName = T2W((LPTSTR)comp_name.utf16());
					ServerInfo->pAuthInfo = NULL;
					
					if (!ui.login_lineEdit->text().isEmpty())
					{
						COAUTHIDENTITY *AuthIdentity = new COAUTHIDENTITY();
						AuthIdentity->Domain = (USHORT*)ui.domain_lineEdit->text().utf16();
						AuthIdentity->DomainLength = wcslen(ui.domain_lineEdit->text().utf16());
						AuthIdentity->User = (USHORT*)ui.login_lineEdit->text().utf16();
						AuthIdentity->UserLength = wcslen(ui.login_lineEdit->text().utf16());
						AuthIdentity->Password = (USHORT*)ui.passwords_lineEdit->text().utf16();
						AuthIdentity->PasswordLength = wcslen(ui.passwords_lineEdit->text().utf16());
						AuthIdentity->Flags = SEC_WINNT_AUTH_IDENTITY_UNICODE;				

						COAUTHINFO *AuthInfo = new COAUTHINFO();
						AuthInfo->dwAuthnSvc           = RPC_C_AUTHN_WINNT;
						AuthInfo->dwAuthzSvc           = RPC_C_AUTHZ_NONE;
						AuthInfo->pwszServerPrincName  = NULL;
						AuthInfo->dwAuthnLevel         = RPC_C_AUTHN_LEVEL_CONNECT;
						AuthInfo->dwImpersonationLevel = RPC_C_IMP_LEVEL_IMPERSONATE;
						AuthInfo->dwCapabilities = EOAC_NONE;

						AuthInfo->pAuthIdentityData = AuthIdentity;
						ServerInfo->pAuthInfo = AuthInfo;		
						//Sleep(100); //     ????
					}


					MULTI_QI queue [1];
					queue [0].pIID = &IID_IOPCServer;
					queue [0].pItf = NULL;
					queue [0].hr   = 0;

					HRESULT hres = CoCreateInstanceEx(myguid, NULL, CLSCTX_ALL, ServerInfo, 1, queue); // 
					if (hres == S_OK)
					{
						m_opcServer = (IOPCServer *) queue[0].pItf;	
																		
						get_opcserver_status(itm_data[2]);
						ui.toolButton->setEnabled(true);
						
						hres = m_opcServer->QueryInterface(IID_IOPCBrowseServerAddressSpace, (void**)&p_da_Browser);
						if  (SUCCEEDED(hres))
						{					
							mysrv running_srv;	//    											
							running_srv.server_name = itm_data[1];
							running_srv.opcServer = m_opcServer;
							running_srv.guid = myguid;
							running_srv.cur_browse_item = p_da_Browser;
							run_servers.append(running_srv);								
							
							current_opc_server_name = current->text(0);
							QSplashScreen splash(QPixmap(":/png/splash.png")); 
							splash.move(QCursor::pos());
							splash.show();
							splash.showMessage(" ", Qt::AlignBottom);	
							current->takeChildren();
							DisplayChildren(current);						
						}
					}
					else
					{
						ui.VendorInfo->clear();
						ui.ftCurrentTime->clear();
						ui.s_version->clear();
						ui.wBuildNumber->clear();
						ui.my_guid->clear();
						QString err = QString::fromUtf16(_com_error(hres).ErrorMessage());
						QMessageBox::warning(0, "!",err);
					}

					if (ServerInfo)
					{
						delete (ServerInfo);
						ServerInfo = NULL;
					}

				return;
				}
				else
					if (itm_data[0] == "OPC_HDA_SERVER_NAME") //  hda  -  
					{						
						if (m_hda_opcServer != NULL)
							m_hda_opcServer.Release();

						QUuid hda_myguid(itm_data[2]);

						for (int i = 0; i<hda_run_servers.count();i++)
						{
							if (hda_run_servers[i].server_name == itm_data[1] && hda_run_servers[i].guid == hda_myguid)	//     	
							{									  							 
								m_hda_opcServer = hda_run_servers[i].hda_opcServer;
								p_hda_Browser = hda_run_servers[i].p_hda_Browser;
								get_hda_opcserver_status(itm_data[2]);
								ui.toolButton->setEnabled(false);
								current->takeChildren();
								Display_HDA_Children(current);							  
								return;
							}
						}

						QUuid myguid(itm_data[2]);
						QString comp_name = itm_data[1];
						COSERVERINFO *ServerInfo = new COSERVERINFO();
						ServerInfo->pwszName = T2W((LPTSTR)comp_name.utf16());
						ServerInfo->pAuthInfo = NULL;

						if (!ui.login_lineEdit->text().isEmpty())
						{
							COAUTHIDENTITY *AuthIdentity = new COAUTHIDENTITY();
							AuthIdentity->Domain = (USHORT*)ui.domain_lineEdit->text().utf16();
							AuthIdentity->DomainLength = wcslen(ui.domain_lineEdit->text().utf16());
							AuthIdentity->User = (USHORT*)ui.login_lineEdit->text().utf16();
							AuthIdentity->UserLength = wcslen(ui.login_lineEdit->text().utf16());
							AuthIdentity->Password = (USHORT*)ui.passwords_lineEdit->text().utf16();
							AuthIdentity->PasswordLength = wcslen(ui.passwords_lineEdit->text().utf16());
							AuthIdentity->Flags = SEC_WINNT_AUTH_IDENTITY_UNICODE;				

							COAUTHINFO *AuthInfo = new COAUTHINFO();
							AuthInfo->dwAuthnSvc           = RPC_C_AUTHN_WINNT;
							AuthInfo->dwAuthzSvc           = RPC_C_AUTHZ_NONE;
							AuthInfo->pwszServerPrincName  = NULL;
							AuthInfo->dwAuthnLevel         = RPC_C_AUTHN_LEVEL_CONNECT;
							AuthInfo->dwImpersonationLevel = RPC_C_IMP_LEVEL_IMPERSONATE;
							AuthInfo->dwCapabilities = EOAC_NONE;

							AuthInfo->pAuthIdentityData = AuthIdentity;
							ServerInfo->pAuthInfo = AuthInfo;

							//Sleep(100);//     ????
						}

						MULTI_QI queue [1];
						queue [0].pIID = &IID_IOPCHDA_Server;
						queue [0].pItf = NULL;
						queue [0].hr   = 0;

						HRESULT hres = CoCreateInstanceEx(myguid, NULL, CLSCTX_ALL, ServerInfo, 1, queue); // 
						if (hres == S_OK)
						{
							m_hda_opcServer = (IOPCHDA_Server *) queue[0].pItf;
							tagOPCHDA_OPERATORCODES Operator = OPCHDA_EQUAL;
							VARIANT vFilter;			
							HRESULT *pErrors;
							unsigned long dwCount = 0;
							unsigned long dwAttrID = 0;

							hres = m_hda_opcServer->CreateBrowse(dwCount,&dwAttrID,&Operator, &vFilter, &p_hda_Browser, &pErrors);
							if (SUCCEEDED(hres))
							{								
								hda_mysrv running_hda_srv;	//    											
								running_hda_srv.server_name = itm_data[1];
								running_hda_srv.hda_opcServer = m_hda_opcServer;
								running_hda_srv.guid = myguid;
								running_hda_srv.p_hda_Browser = p_hda_Browser;
								hda_run_servers.append(running_hda_srv);																																					
								get_hda_opcserver_status(itm_data[2]);
								ui.toolButton->setEnabled(false);
								current->takeChildren();
								Display_HDA_Children(current);	
							}
						}
						else
						{
							QString err = QString::fromUtf16(_com_error(hres).ErrorMessage());
							QMessageBox::warning(0, "!",err);
						}
						
						if (ServerInfo)
						{
							delete (ServerInfo);
							ServerInfo = NULL;
						}

						return;
					}
				else
					if (itm_data[0] == "OPC_BRANCH") //  opc DA  -   
					{																																		
						QTreeWidgetItem *itm = current;
						QString m_server_name = "";
						QUuid myguid;
						while (itm->parent())
						{
							itm = itm->parent();
							QStringList dt = itm->data(0,Qt::UserRole).toStringList();
							if (dt.size() == 3)
							{										
								if (dt[0] == "OPC_DA_SERVER_NAME" )
								{
									m_server_name = dt[1];
									myguid = (dt[2]);	
									break;
								}															
							}
						}
						for (int i=0; i<run_servers.count();i++)
						{
							if (run_servers[i].server_name == m_server_name && run_servers[i].guid == myguid )
							{
								p_da_Browser = run_servers[i].cur_browse_item;
								m_opcServer = run_servers[i].opcServer;
								break;
							}
						}
						
						HRESULT hres = p_da_Browser->ChangeBrowsePosition(OPC_BROWSE_TO, itm_data[1].utf16());
						if (SUCCEEDED(hres))
						{
							current->takeChildren();
							DisplayChildren(current);						
						}
								else // OPC_BROWSE_TO  
								{
									QString err = QString::fromUtf16(_com_error(hres).ErrorMessage());
									QMessageBox::warning(0, "!","ChangeBrowsePosition(OPC_BROWSE_TO)  : "+err);
									
									QTreeWidgetItem *item = current;
									QString parents_name = "";
									while (item->parent())
									{
										item = item->parent();
										parents_name = item->text(0)+"\n"+parents_name;
									}

									int position = parents_name.indexOf(current_opc_server_name);
									parents_name.remove(0, position+current_opc_server_name.size()+1);
									parents_name = parents_name+current->text(0);

									QStringList parrent_list = parents_name.split("\n");
									 do   	   	
									  hres = p_da_Browser->ChangeBrowsePosition (OPC_BROWSE_UP, L"\0");   
									   while (SUCCEEDED (hres));

										 foreach(QString patch, parrent_list)
										 {
											hres = p_da_Browser->ChangeBrowsePosition(OPC_BROWSE_DOWN, patch.utf16());
											if (!SUCCEEDED(hres))						
											{												
												QMessageBox::warning(0, "!","OPC_BROWSE_DOWN    "+QString::fromUtf16(_com_error(hres).ErrorMessage()));
												return;
											}
										 }
										 current->takeChildren();
										 DisplayChildren(current);
								}
																																		
						return;
					}
					else
						if (itm_data[0]=="OPCHDA_BRANCH") //  opc HDA  - .....
						{
							HRESULT hres = p_hda_Browser->ChangeBrowsePosition(OPCHDA_BROWSE_DIRECT, itm_data[1].utf16());
							if (SUCCEEDED(hres))
							{
								current->takeChildren();
								Display_HDA_Children(current);						
							}
						}
						return;
			}
			else
				if (itm_data.size() == 0)				
				return;
				
			enum_network(current);		
	}
}

FILETIME DateToFileTime(DATE *pdate)
{
	__int64 temp = (__int64)((*pdate + (double)(363 + (1899 - 1601) * 365 + (24 + 24 + 24))) * 8.64e11);
	return *(FILETIME *)&temp;
}

QStringList my_opc::get_value(VARIANT *my_tag)
{
	QStringList items;
	QString tagtype = "";

	if (!my_tag)
	{
	    items<<""<<"";
		return items;
	}

			switch( my_tag->vt )
			{
			case VT_I1: //SByte
				{
					char b = my_tag->cVal;
					temp_str = temp_str+QString::number(b)+"\n";
				}
				break;
			case VT_UI1: //Byte
				{
					byte b = my_tag->bVal;
					temp_str = temp_str+QString::number(b)+"\n";
				}
				break;
			case VT_I2: //Short
				{
					short b = my_tag->iVal;
					temp_str = temp_str+QString::number(b)+"\n";
				}
				break;
			case VT_UI2: //UShort
				{
					ushort b = my_tag->uiVal;
					temp_str = temp_str+QString::number(b)+"\n";
				}
				break;
			case VT_I4:
				{
					int b = my_tag->intVal;
					temp_str = temp_str+QString::number(b)+"\n";
				}
				break;
			case VT_UI4:
				{
					uint b = my_tag->uintVal;					
					temp_str = temp_str+QString::number(b)+"\n";
				}
				break;
			case VT_I8:
				{
					LONGLONG b = my_tag->llVal;					
					temp_str = temp_str+QString::number(b)+"\n";
				}
				break;
			case VT_UI8:
				{
					ULONGLONG b = my_tag->ullVal;
					temp_str = temp_str+QString::number(b)+"\n";
				}
				break;
			case VT_R4:
				{
					float b = my_tag->fltVal;					
					temp_str = temp_str+QString::number(b)+"\n";
				}
				break;
			case VT_R8:
				{
					double b = my_tag->dblVal;
					temp_str = temp_str+QString::number(b)+"\n";
				}
				break;
			case VT_CY:
				{
					BSTR bbb;
					CY b  = my_tag->cyVal;					
					VarBstrFromCy(b,2048,LOCALE_NOUSEROVERRIDE,&bbb);					
					temp_str = temp_str+QString::fromUtf16(bbb)+"\n";					
				}
				break;
			case VT_BOOL:
				{
					VARIANT_BOOL b = my_tag->boolVal;					
					b = b ? 1 : 0;
					temp_str = temp_str+QString::number(b)+"\n";
				}
				break;
			case VT_DATE:
				{
					DATE b = my_tag->date;					
					FILETIME ftime =  DateToFileTime(&b);
					SYSTEMTIME st;
					QString curr_time;
					if (FileTimeToSystemTime(&ftime, &st))
						curr_time = SystemTime_to_QString(st);
					else
						curr_time = "";
					temp_str = temp_str+curr_time+"\n";
				}
				break;
			case  VT_BSTR:
				{
					BSTR b = my_tag->bstrVal;					
					temp_str = temp_str+"''"+QString::fromUtf16(b)+"''"+"\n";
				}
				break;
				
			default:
				{
					if ((my_tag->vt & VT_ARRAY) == VT_ARRAY)
					{
						tagtype = "(VT_ARRAY)";
						LONG cElements = 0, lLBound = 0, lUBound = 0;
						SafeArrayGetLBound(my_tag->parray, 1, &lLBound);
						SafeArrayGetUBound(my_tag->parray, 1, &lUBound);
						cElements = lUBound-lLBound+1;

						for (long i = 0; i < cElements; i++)
						{
							switch( my_tag->vt & ~VT_ARRAY )
							{
							        case VT_I1: //SByte
									{
										char b;
										SafeArrayGetElement(my_tag->parray, &i, &b);
										temp_str = temp_str+QString::number(b)+"\n";
									}
									 break;
									case VT_UI1: //Byte
										{
											byte b;
											SafeArrayGetElement(my_tag->parray, &i, &b);
											temp_str = temp_str+QString::number(b)+"\n";
										}
									break;
									case VT_I2: //Short
										{
											short b;
											SafeArrayGetElement(my_tag->parray, &i, &b);
											temp_str = temp_str+QString::number(b)+"\n";
										}
									break;
									case VT_UI2: //UShort
										{
											ushort b;
											SafeArrayGetElement(my_tag->parray, &i, &b);
											temp_str = temp_str+QString::number(b)+"\n";
										}
									break;
									case VT_I4:
										{
											int b;
											SafeArrayGetElement(my_tag->parray, &i, &b);
											temp_str = temp_str+QString::number(b)+"\n";
										}
									break;
									case VT_UI4:
										{
											uint b;
											SafeArrayGetElement(my_tag->parray, &i, &b);
											temp_str = temp_str+QString::number(b)+"\n";
										}
									break;
									case VT_I8:
										{
											LONGLONG b;
											SafeArrayGetElement(my_tag->parray, &i, &b);
											temp_str = temp_str+QString::number(b)+"\n";
										}
									break;
									case VT_UI8:
										{
											ULONGLONG b;
											SafeArrayGetElement(my_tag->parray, &i, &b);
											temp_str = temp_str+QString::number(b)+"\n";
										}
									break;
									case VT_R4:
										{
											float b;
											SafeArrayGetElement(my_tag->parray, &i, &b);
											temp_str = temp_str+QString::number(b)+"\n";
										}
									break;
									case VT_R8:
										{
											double b;
											SafeArrayGetElement(my_tag->parray, &i, &b);
											temp_str = temp_str+QString::number(b)+"\n";
										}
									break;
									case VT_CY:
										{
											BSTR bbb;
											CY b;
											SafeArrayGetElement(my_tag->parray, &i, &b);													
											VarBstrFromCy(b,2048,LOCALE_NOUSEROVERRIDE,&bbb);					
											temp_str = temp_str+QString::fromUtf16(bbb)+"\n";					
										}
									break;
									case VT_BOOL:
										{
											VARIANT_BOOL b;
											SafeArrayGetElement(my_tag->parray, &i, &b);
											b = b ? 1 : 0;
											temp_str = temp_str+QString::number(b)+";\n";
										}
									break;
									case VT_DATE:
										{
											DATE b;
											SafeArrayGetElement(my_tag->parray, &i, &b);
											FILETIME ftime =  DateToFileTime(&b);
											SYSTEMTIME st;
											FileTimeToSystemTime(&ftime,&st);
											//SystemTimeToTzSpecificLocalTime(NULL, &stUTC, &stLocal);
											//QString curr_time = QString::number(st.wDay)+"."+QString::number(st.wMonth)+"."+QString::number(st.wYear)+" "
												//+QString::number(st.wHour)+":"+QString::number(st.wMinute)+":"+QString::number(st.wSecond);
											QString curr_time = SystemTime_to_QString(st);
											temp_str = temp_str+curr_time+" (DateTime);\n";
										}
									break;
									case  VT_BSTR:
										{
											BSTR b;
											SafeArrayGetElement(my_tag->parray, &i, &b);
											temp_str = temp_str+"''"+QString::fromUtf16(b)+"''"+"\n";
										}
									break;
									case VT_VARIANT:
										{
											VARIANT b;
											SafeArrayGetElement(my_tag->parray, &i, &b);
											get_value(&b);
										}
							}
						}
					}
				}
			}

	switch( my_tag->vt & ~VT_ARRAY )
	{
	case VT_I1: tagtype = tagtype+"VT_I1"; break;
	case VT_UI1: tagtype = tagtype+"VT_UI1"; break;
	case VT_I2: tagtype = tagtype+"VT_I2"; break;
	case VT_UI2: tagtype = tagtype+"VT_UI2"; break;
	case VT_I4: tagtype = tagtype+"VT_I4"; break;
	case VT_UI4: tagtype = tagtype+"VT_UI4"; break;
	case VT_I8: tagtype = tagtype+"VT_I8"; break;
	case VT_UI8: tagtype = tagtype+"VT_UI8"; break;
	case VT_R4: tagtype = tagtype+"VT_R4"; break;
	case VT_R8: tagtype = tagtype+"VT_R8"; break;
	case VT_CY: tagtype = tagtype+"VT_CY"; break;
	case VT_BOOL: tagtype = tagtype+"VT_BOOL"; break;
	case VT_DATE: tagtype = tagtype+"VT_DATE"; break;
	case VT_BSTR: tagtype = tagtype+"VT_BSTR"; break;	
	case VT_VARIANT: tagtype = tagtype+"VT_VARIANT"; break;
	default: tagtype = "Unknown Type";
	}
	
	items<<temp_str<<tagtype;

	return items;
}

void my_opc::on_toolButton_clicked()
{		
	if (ui.lineEdit->text().size() == 0)
		return;
	
	OPCHANDLE phServerGroup = 0;
	IOPCItemMgt *pItemMgt = NULL;
	QUuid server_guid;
	    
		DWORD updateRate = 1000;
		HRESULT hr;

		if (!m_opcServer)
			return;

		ui.tabWidget->setCurrentIndex(0);
		
		hr = m_opcServer->GetGroupByName(_T("MyGroup"), __uuidof(IOPCItemMgt), (IUnknown**)&pItemMgt);
		if (!SUCCEEDED(hr))					
		    hr = m_opcServer->AddGroup(_T("MyGroup"), true, updateRate, 1, NULL, NULL, 0, &phServerGroup, &updateRate, __uuidof(IOPCItemMgt), (IUnknown**)&pItemMgt);				
		if (SUCCEEDED(hr))
		{			        					
					DWORD dwCount = 1;		
					tagOPCITEMDEF* pItems = (tagOPCITEMDEF*)CoTaskMemAlloc(dwCount*sizeof(tagOPCITEMDEF));

					if (!pItems)
					{
						QMessageBox::warning(0, "!", "    CoTaskMemAlloc");
						return;
					}

				    tagOPCITEMRESULT* pResults = NULL;
					HRESULT* pErrors = NULL;
					pItems[0].szItemID = bstr_t(ui.lineEdit->text().utf16());        //    					
					pItems[0].szAccessPath =  _T("");
					pItems[0].bActive = TRUE;
					pItems[0].hClient = 0;
					pItems[0].vtRequestedDataType = VT_EMPTY;
					pItems[0].dwBlobSize = 0;
					pItems[0].pBlob = NULL;

					
					hr = pItemMgt->AddItems(1, pItems, &pResults, &pErrors);
					if (SUCCEEDED(hr) && hr != S_FALSE)
					{						 																		
						            IOPCSyncIO * pSyncIO = NULL;
									IID IID_IOPCSYNCIO =__uuidof(IOPCSyncIO);
									hr=pItemMgt->QueryInterface(IID_IOPCSYNCIO,(void**)&pSyncIO);

									myhwnd hw;
									hw.srv_results = &pResults->hServer;
									hw.syncio = pSyncIO;
									hw.ItemMgt = pItemMgt;
									hw.itemID = ui.lineEdit->text();

									QTreeWidgetItem *itm = ui.treeWidget->currentItem();
									QString m_server_name = "";									
									while (itm->parent())
									{
										itm = itm->parent();
										QStringList dt = itm->data(0,Qt::UserRole).toStringList();
										if (dt.size() == 3)
										{										
											if (dt[0] == "OPC_DA_SERVER_NAME" )
											{
												m_server_name = dt[1];
												server_guid  = dt[2];
												break;
											}															
										}
									}

									hw.server_name = m_server_name;
									hw.myId = id;	
									hw.add_grp_handle = phServerGroup;
									hw.srv_guid = server_guid;
									hwnds.append(hw);
									id++;

									if (!update_timer->isActive())
										update_timer->start(1000);									
					}
					else
					{
						LPWSTR lpError;
						m_opcServer->GetErrorString(*pErrors,2,&lpError);						
						QString err = QString::fromUtf16(lpError);
						if (err.isEmpty())
							err = QString::fromUtf16(_com_error(hr).ErrorMessage());
						QMessageBox::warning(0, "!","    : "+err);
					}

					CoTaskMemFree(pErrors);
					CoTaskMemFree(pItems);						
        }
		else
		{
			QString err = QString::fromUtf16(_com_error(hr).ErrorMessage());
			QMessageBox::warning(0, "!","    : "+err);
		}

		if (pItemMgt)
			pItemMgt->Release();
}

QString my_opc::SystemTime_to_QString(SYSTEMTIME st)
{
 QDateTime dd (QDate (st.wYear, st.wMonth, st.wDay), QTime (st.wHour, st.wMinute, st.wSecond, st.wMilliseconds));
 QString s = dd.toString("dd.MM.yyyy H:mm:ss.zzz");
 return s;
}

QString my_opc::get_err(const HRESULT &pErrors)
{
	if (&pErrors)
	{
	if (pErrors == OPC_E_MAXEXCEEDED)
		return "The maximum number of values requested exceeds the server's limit.";
	else
		if (pErrors == OPC_S_NODATA)
			return "There is no data with in the specified parameters.";
		else
		if (pErrors == OPC_S_MOREDATA)
			return "There is more data satisfying the query than was returned.";
			else
				if (pErrors == OPC_E_INVALIDAGGREGATE)
					return "The aggregate requested is not valid.";
				else
					if (pErrors == OPC_S_CURRENTVALUE)
						return "The server only returns current values for the requested item attributes.";
					else
						if (pErrors == OPC_S_EXTRADATA)
							return "Additional data satisfying the query was found.";
						else
							if (pErrors == OPC_W_NOFILTER)
								return "The server does not support this filter.";
							else
								if (pErrors == OPC_E_UNKNOWNATTRID)
									return "The server does not support this attribute.";
								else
									if (pErrors == OPC_E_NOT_AVAIL)
										return "The requested aggregate is not available for the specified item.";
									else
										if (pErrors == OPC_E_INVALIDDATATYPE)
											return "The supplied value for the attribute is not a correct data type.";
										else
											if (pErrors == OPC_E_DATAEXISTS)
												return "Unable to insert - data already present.";
											else
												if (pErrors == OPC_E_INVALIDATTRID)
													return "The supplied attribute ID is not valid.";
												else
													if (pErrors == OPC_E_NODATAEXISTS)
														return "The server has no value for the specified time and item ID.";
													else
														if (pErrors == OPC_S_INSERTED)
															return "The requested insert occurred.";
														else
															if (pErrors == OPC_S_REPLACED)
																return "The requested replace occurred.";
															else
																if (pErrors == E_NOTIMPL)
																	return "This server does not support this function.";
	}
	return "The function was unsuccessful.";
}

void my_opc::on_get_hda_value_Button_clicked()
{
	if (m_hda_opcServer != NULL)
	{
		DWORD dwCount = 1;
		unsigned long phClient=0;
		OPCHANDLE *hItems = NULL;
		HRESULT *pErrors = 0;
		HRESULT hRes;
		LPWSTR itemid = bstr_t(ui.lineEdit->text().utf16());
		hRes = m_hda_opcServer->GetItemHandles(dwCount, &itemid, &phClient, &hItems, &pErrors);
		if (SUCCEEDED(hRes))
	    {		
			IOPCHDA_SyncRead *pSyncIO;
			hRes = m_hda_opcServer->QueryInterface(IID_IOPCHDA_SyncRead,(void**)&pSyncIO);
			if (SUCCEEDED(hRes))
			{
				if (ui.ReadRawButton->isChecked())
				{					
					unsigned long dwMaxValuesCount = 0;
					bool bBounds = false;
					OPCHDA_ITEM *pItemValues;

					hRes = pSyncIO->ReadRaw(&getstarttime(), &getendtime(), dwMaxValuesCount, bBounds, dwCount, hItems, &pItemValues, &pErrors);
					if (hRes == S_OK)
					{											
						for (int i = 0;i<pItemValues->dwCount;i++)
						{							
							
							FILETIME tag_time = pItemValues[0].pftTimeStamps[i];
							SYSTEMTIME st;
							FileTimeToSystemTime(&tag_time,&st);
							
							QString tagtime = SystemTime_to_QString(st);
																					
							temp_str  = "";
							QStringList items = get_value(&pItemValues[0].pvDataValues[i]);
							ui.tableWidget_3->insertRow(0);	
							QTableWidgetItem *value_item = new QTableWidgetItem();
							value_item->setData(0,items[0]);
							ui.tableWidget_3->setItem(0, 0, value_item);

							QTableWidgetItem *time_item = new QTableWidgetItem();
							time_item->setData(0,tagtime);
							ui.tableWidget_3->setItem(0, 1, time_item);

							QTableWidgetItem *type_item = new QTableWidgetItem();
							type_item->setData(0,items[1]);
							ui.tableWidget_3->setItem(0, 2, type_item);
							
							QString quality = get_hda_quality(pItemValues[0].pdwQualities[i]);														
							QTableWidgetItem *Qualities_item = new QTableWidgetItem();
							Qualities_item->setData(0,quality);
							ui.tableWidget_3->setItem(0, 3, Qualities_item);

						}
					}
					else
					{
						QString err = get_err(*pErrors);
						QMessageBox::warning(0, "!",": "+err);
					}
				}
				else
					if (ui.ReadAtTimeButton->isChecked())
					{
						OPCHDA_TIME opcStartTime = getstarttime();
						OPCHDA_ITEM *pItemValues;
						
						hRes = pSyncIO->ReadAtTime(1, &opcStartTime.ftTime,1,hItems,&pItemValues,&pErrors); //ok

						if (hRes == S_OK)
						{
							for (int i = 0;i<pItemValues->dwCount;i++)
							{
								FILETIME tag_time = pItemValues[0].pftTimeStamps[i];
								SYSTEMTIME st;
								FileTimeToSystemTime(&tag_time,&st);

								QString tagtime = SystemTime_to_QString(st);


								temp_str  = "";
								QStringList items = get_value(&pItemValues[0].pvDataValues[i]);
								ui.tableWidget_3->insertRow(0);	
								QTableWidgetItem *value_item = new QTableWidgetItem();
								value_item->setData(0,items[0]);
								ui.tableWidget_3->setItem(0, 0, value_item);

								QTableWidgetItem *time_item = new QTableWidgetItem();
								time_item->setData(0,tagtime);
								ui.tableWidget_3->setItem(0, 1, time_item);

								QTableWidgetItem *type_item = new QTableWidgetItem();
								type_item->setData(0,items[1]);
								ui.tableWidget_3->setItem(0, 2, type_item);

								QString quality = get_hda_quality(pItemValues[0].pdwQualities[i]);
								QTableWidgetItem *Qualities_item = new QTableWidgetItem();
								Qualities_item->setData(0,quality);
								ui.tableWidget_3->setItem(0, 3, Qualities_item);
							}
						}
						else
						{
							QString err = get_err(*pErrors);
							QMessageBox::warning(0, "!",": "+err);
						}
					}
					else
						if (ui.ReadProcessedButton->isChecked())
						{
							int m_dwInterval = ui.ResampleInterval->value();
							const __int64 iResInt = (__int64)m_dwInterval*60*10000000;
							FILETIME ftResInterval;
							ftResInterval.dwLowDateTime = iResInt;
							ftResInterval.dwHighDateTime = (iResInt >> 32);												
							unsigned long dwAggregateID = ui.Processed_comboBox->currentText().toInt();	
							OPCHDA_ITEM *pItemValues;
							hRes = pSyncIO->ReadProcessed(&getstarttime(), &getendtime(),ftResInterval,dwCount,hItems,&dwAggregateID,&pItemValues,&pErrors);
							if (hRes == S_OK)
							{
								for (int i = 0;i<pItemValues->dwCount;i++)
								{
									FILETIME tag_time = pItemValues[0].pftTimeStamps[i];
									SYSTEMTIME st;
									FileTimeToSystemTime(&tag_time,&st);

									QString tagtime = SystemTime_to_QString(st);


									temp_str  = "";
									QStringList items = get_value(&pItemValues[0].pvDataValues[i]);
									ui.tableWidget_3->insertRow(0);	
									QTableWidgetItem *value_item = new QTableWidgetItem();
									value_item->setData(0,items[0]);
									ui.tableWidget_3->setItem(0, 0, value_item);

									QTableWidgetItem *time_item = new QTableWidgetItem();
									time_item->setData(0,tagtime);
									ui.tableWidget_3->setItem(0, 1, time_item);

									QTableWidgetItem *type_item = new QTableWidgetItem();
									type_item->setData(0,items[1]);
									ui.tableWidget_3->setItem(0, 2, type_item);

									QString quality = get_hda_quality(pItemValues[0].pdwQualities[i]);
									QTableWidgetItem *Qualities_item = new QTableWidgetItem();
									Qualities_item->setData(0,quality);
									ui.tableWidget_3->setItem(0, 3, Qualities_item);
								}
							}
							else
							{
								QString err = get_err(*pErrors);
								QMessageBox::warning(0, "!",": "+err);
							}
						}
						else
							if (ui.ReadAttributeButton->isChecked())
							{
								unsigned long dwAttrID = ui.Attribute_comboBox->currentText().toInt();
								OPCHDA_ATTRIBUTE *attr;
								hRes = pSyncIO->ReadAttribute(&getstarttime(), &getendtime(), *hItems, 1, &dwAttrID, &attr, &pErrors ); //ok
								if (SUCCEEDED(hRes) && attr->vAttributeValues)
								//if (hRes == S_OK)
								{
									temp_str  = "";
									QStringList items = get_value(attr->vAttributeValues);

									ui.tableWidget_3->insertRow(0);	
									QTableWidgetItem *value_item = new QTableWidgetItem();
									value_item->setData(0,items[0]);
									ui.tableWidget_3->setItem(0, 0, value_item);
									
									FILETIME tag_time = *attr->ftTimeStamps;
									SYSTEMTIME st;
									QString tagtime;
									if (FileTimeToSystemTime(&tag_time, &st))
										tagtime = SystemTime_to_QString(st);
									else
										tagtime = "";
									QTableWidgetItem *time_item = new QTableWidgetItem();
									time_item->setData(0,tagtime);
									ui.tableWidget_3->setItem(0, 1, time_item);

									QTableWidgetItem *type_item = new QTableWidgetItem();
									type_item->setData(0,items[1]);
									ui.tableWidget_3->setItem(0, 2, type_item);

									QString quality = " ";
									QTableWidgetItem *Qualities_item = new QTableWidgetItem();
									Qualities_item->setData(0,quality);
									ui.tableWidget_3->setItem(0, 3, Qualities_item);
								}
								else
								{
									QString err = get_err(*pErrors);
									QMessageBox::warning(0, "!",": "+err);
								}
							}
			}
		}
		CoTaskMemFree(pErrors);
	}
}

void my_opc::clear_tableWidget()
{
	QModelIndexList currentSelection = ui.tableWidget->selectionModel()->selectedRows();
	qSort(currentSelection.begin(),currentSelection.end(),qGreater<QModelIndex>());
	QModelIndex index;

	if (currentSelection.count()!=0)
	{		
		foreach(index, currentSelection) 
		{
			int idx =  ui.tableWidget->item(index.row(),6)->data(2).toInt();
			for (int i=0; i<hwnds.count();i++)
			{
				if (hwnds[i].myId == idx)
				{
					HRESULT *pErrors, h;					
					h = hwnds[i].ItemMgt->RemoveItems(1, hwnds[i].srv_results,&pErrors);										
					hwnds.remove(i);										
					break;
				}
			}

			ui.tableWidget->removeRow(index.row());			
		}				
	}
}

void my_opc::clear_all_tableWidget()
{	
	for (int i=0; i<hwnds.count();i++)
	{
		HRESULT *pErrors, h;					
		h = hwnds[i].ItemMgt->RemoveItems(1, hwnds[i].srv_results,&pErrors);																						
	}
	
	hwnds.clear();
	ui.tableWidget->setRowCount(0);
}

void my_opc::clear_hda_tableWidget()
{
	QModelIndexList currentSelection = ui.tableWidget_3->selectionModel()->selectedRows();
	qSort(currentSelection.begin(),currentSelection.end(),qGreater<QModelIndex>());
	QModelIndex index;

	if (currentSelection.count()!=0)
	{
		foreach(index, currentSelection) 		
			ui.tableWidget_3->removeRow(index.row());						
	}
}

void my_opc::clear_all_hda_tableWidget()
{
	ui.tableWidget_3->setRowCount(0);
}

void my_opc::stop_start_browse_da_values()
{
	if (update_timer->isActive())
		update_timer->stop();
	else
	{
		if (hwnds.count() > 0)
		   update_timer->start(1000);
	}
}

void my_opc::save_to_html(QPrinter* printer)
{
	print_opc_info(ui.tableWidget)->print(printer);
}

void my_opc::save_hda_to_html(QPrinter* printer)
{
	print_opc_info(ui.tableWidget_3)->print(printer);
}


void my_opc::print_to_html()
{
	/*QPrinter printer;
	printer.setOrientation(QPrinter::Landscape);
	printer.setPaperSize(QPrinter::A4);
	printer.setPageMargins(10,10,10,2,QPrinter::Millimeter);
	QPrintPreviewDialog preview(&printer, this);
	preview.resize(qApp->desktop()->availableGeometry(this).width(), qApp->desktop()->availableGeometry(this).height());
	connect(&preview, SIGNAL(paintRequested(QPrinter*)), SLOT(save_to_html(QPrinter*)));
	preview.exec();	*/

	QString htmlfile =  QFileDialog::getSaveFileName(this, tr("  "),"",tr("html (*.html)"));
	if (!htmlfile.isEmpty())	
	{
		QFile file(htmlfile);
		QTextDocumentWriter writer;
		writer.setDevice(&file);
		writer.setFormat("HTML");

		if (writer.write(print_opc_info(ui.tableWidget)))
		{
			QMessageBox::StandardButton ret;
			ret=QMessageBox::question(this, " ","   ?", QMessageBox::Ok | QMessageBox::Cancel);
			if (ret==QMessageBox::Ok)
			{
				if (file.exists())	
				{
					QString lsParameters = "shell32.dll,OpenAs_RunDLL ";
					htmlfile = lsParameters+htmlfile;
					QVarLengthArray<wchar_t, MAX_PATH> fullPath;
					UINT retLen = ::GetSystemDirectory(fullPath.data(), MAX_PATH);
					if (retLen > MAX_PATH) 
					{
						fullPath.resize(retLen);
						retLen = ::GetSystemDirectory(fullPath.data(), retLen);
					}						
					QString windir =  QString::fromWCharArray(fullPath.constData(), int(retLen));
					QString rundll32 = windir+"\\RUNDLL32.EXE";
					HINSTANCE code = 0;
					code = ShellExecute(GetDesktopWindow(), L"open", rundll32.utf16(), QDir::toNativeSeparators(htmlfile).utf16(), L'', SW_SHOWNORMAL);	
					int run_code = int(code);
					if (run_code < 32)
						QMessageBox::warning(this, "","  !");

				}
				else
					QMessageBox::warning(this, tr("!"), "  "+htmlfile);
			}
		}
	}	
}

void my_opc::print_hda_to_html()
{
	/*QPrinter printer;
	printer.setOrientation(QPrinter::Landscape);
	printer.setPaperSize(QPrinter::A4);
	printer.setPageMargins(10,10,10,2,QPrinter::Millimeter);
	QPrintPreviewDialog preview(&printer, this);
	preview.resize(qApp->desktop()->availableGeometry(this).width(), qApp->desktop()->availableGeometry(this).height());
	connect(&preview, SIGNAL(paintRequested(QPrinter*)), SLOT( save_hda_to_html(QPrinter*)));
	preview.exec();*/	

	QString htmlfile =  QFileDialog::getSaveFileName(this, tr("  "),"",tr("html (*.html)"));
	if (!htmlfile.isEmpty())	
	{
		QFile file(htmlfile);
		QTextDocumentWriter writer;
		writer.setDevice(&file);
		writer.setFormat("HTML");

		if (writer.write(print_opc_info(ui.tableWidget_3)))
		{
			QMessageBox::StandardButton ret;
			ret=QMessageBox::question(this, " ","   ?", QMessageBox::Ok | QMessageBox::Cancel);
			if (ret==QMessageBox::Ok)
			{
				if (file.exists())	
				{
					QString lsParameters = "shell32.dll,OpenAs_RunDLL ";
					htmlfile = lsParameters+htmlfile;
					QVarLengthArray<wchar_t, MAX_PATH> fullPath;
					UINT retLen = ::GetSystemDirectory(fullPath.data(), MAX_PATH);
					if (retLen > MAX_PATH) 
					{
						fullPath.resize(retLen);
						retLen = ::GetSystemDirectory(fullPath.data(), retLen);
					}						
					QString windir =  QString::fromWCharArray(fullPath.constData(), int(retLen));
					QString rundll32 = windir+"\\RUNDLL32.EXE";
					HINSTANCE code = 0;
					code = ShellExecute(GetDesktopWindow(), L"open", rundll32.utf16(), QDir::toNativeSeparators(htmlfile).utf16(), L'', SW_SHOWNORMAL);	
					int run_code = int(code);
					if (run_code < 32)
						QMessageBox::warning(this, "","  !");

				}
				else
					QMessageBox::warning(this, tr("!"), "  "+htmlfile);
			}
		}
	}	
}

void my_opc::save_to_file()
{
	QString export_file =  QFileDialog::getSaveFileName(this, tr("  "),"",tr("xml (*.xml)"));
	if (!export_file.isEmpty())
	{
		QFile file(export_file);
		if (!file.open(QIODevice::WriteOnly)) 
		{
			QMessageBox::critical(this, "    !", file.errorString());
			return;
		}
		QXmlStreamWriter stream(&file);
		stream.setAutoFormatting(true);
		stream.writeStartDocument();
		stream.writeStartElement("ITEMS");
		for (int i=0; i<hwnds.count();i++)
		{
			stream.writeStartElement("DA_VALUES");
			stream.writeTextElement("SERVER_NAME", hwnds[i].server_name);
			stream.writeTextElement("HDA_GUID", hwnds[i].srv_guid.toString());
			stream.writeTextElement("itemID", hwnds[i].itemID);
			stream.writeEndElement();
		}
		stream.writeEndElement();
		stream.writeEndDocument();
		file.close();
		QMessageBox::information(this, tr(" "), " " +QFileInfo(file.fileName()).absoluteFilePath()+ "  !");	
	}	
}

void my_opc::load_from_file()
{
	QString import_file = QFileDialog::getOpenFileName(this,tr("    "), "", tr("Xml  (*.xml)"));
	if (!import_file.isEmpty())
	{
		QFile file(import_file);
		if (!file.open(QIODevice::ReadOnly | QFile::Text)) 
		{
			QMessageBox::critical(this, "   !", file.errorString());
			return;
		}

		QString server_name;
		QUuid guid;
		QString itemID;

		my_file_data.clear();

		QXmlStreamReader reader(&file);
		while (!reader.atEnd()) 
		{
			reader.readNext();
			if (reader.name().toString()=="SERVER_NAME")
				 server_name = reader.readElementText().trimmed();
			else
				if (reader.name().toString()=="HDA_GUID")
					guid = reader.readElementText().trimmed();
				else
					if (reader.name().toString()=="itemID")
						itemID = reader.readElementText().trimmed();

			if (reader.isEndElement())
			{
				if (reader.name().toString()=="DA_VALUES")
				{
					saved_file_data fd;
					fd.server_name = server_name;
					fd.guid = guid;
					fd.itemID = itemID;
					my_file_data.append(fd);
				}
			}
		}
		if (reader.hasError())
		{
			QMessageBox::critical(this, "   !", reader.errorString());
			return;
		}

		for (int i=0; i<my_file_data.count();i++)
		{
			if (start_da_server(my_file_data[i].server_name,my_file_data[i].guid))
			{
				add_items_da_server(my_file_data[i].server_name, my_file_data[i].guid, my_file_data[i].itemID);
			}
		}
	}
}

void my_opc::on_tableWidget_customContextMenuRequested(QPoint)
{
	QMenu menu;
	menu.addAction(QIcon(":/png/scan.png"), tr("/  "),this , SLOT(stop_start_browse_da_values()));
	if (!update_timer->isActive())
	{
	menu.addAction(QIcon(":/png/del_1.png"), tr(" "),this , SLOT(clear_tableWidget()));
	menu.addAction(QIcon(":/png/del.png"), tr(" "),this , SLOT(clear_all_tableWidget()));
	}
	menu.addAction(QIcon(":/png/export_1.png"), tr("  HTML"),this , SLOT(print_to_html()));
	menu.addSeparator();
	menu.addAction(QIcon(":/png/export.png"), tr("    "),this , SLOT(save_to_file()));
	menu.addAction(QIcon(":/png/import.png"), tr("    "),this , SLOT(load_from_file()));
	menu.exec(QCursor::pos());
}

void my_opc::on_tableWidget_3_customContextMenuRequested(QPoint)
{
	QMenu menu;
	menu.addAction(QIcon(":/png/del_1.png"), tr(" "),this , SLOT(clear_hda_tableWidget()));
	menu.addAction(QIcon(":/png/del.png"), tr(" "),this , SLOT(clear_all_hda_tableWidget()));
	menu.addAction(QIcon(":/png/export_1.png"), tr("  HTML"),this , SLOT(print_hda_to_html()));
	menu.exec(QCursor::pos());
}

void my_opc::on_treeWidget_customContextMenuRequested(QPoint)
{
	QMenu menu;
	menu.addAction(QIcon(":/png/connect.png"), tr("    IP"),this , SLOT(ip_connect()));
	menu.addSeparator();
	menu.addAction(QIcon(":/png/refresh.png"), tr(" "), this, SLOT(redraw()));
	menu.exec(QCursor::pos());
}

void my_opc::ip_connect()
{
	bool ok;
	QString address = QInputDialog::getText(this, tr("   IP:"),"", QLineEdit::Normal, "", &ok);
    if (!address.isEmpty() && ok)
	{
		QTreeWidgetItem *item;
		item  = new QTreeWidgetItem;

		QStringList item_data;
		item_data<<""<<""<<"2"<<""<<""<<address<<""<<"";			
		item->setData(0, Qt::UserRole, item_data);
		item->setText(0, address);
		item->setChildIndicatorPolicy(QTreeWidgetItem::ShowIndicator);
		ui.treeWidget->addTopLevelItem(item);
	}		
}

void my_opc::redraw()
{
	ui.treeWidget->clear();
	enum_network(NULL);
}

void my_opc::indexChanged( QTreeWidgetItem * current, QTreeWidgetItem * previous)
{
	ui.tableWidget_2->setColumnCount(3);
	ui.tableWidget_2->setRowCount(0);
	ui.tableWidget_2->setSortingEnabled(false);

	if (!current)
		return;		

	QStringList itm_data = current->data(0,Qt::UserRole).toStringList();

	if (itm_data.size() < 1)				
		return;
				
		ui.lineEdit->setText(itm_data[1]);
	
		if (itm_data[1].size() == 0)
			return;

		QTreeWidgetItem *itm = current;
		while (itm->parent())
		{
			itm = itm->parent();
			QStringList dt = itm->data(0,Qt::UserRole).toStringList();
			if (dt.size() == 3)
			{										
				if (dt[0] == "OPC_DA_SERVER_NAME"  && m_opcServer != NULL)
				{
					QString m_server_name = dt[1];
					QUuid myguid = dt[2];									

					for (int i=0; i<run_servers.count();i++)
					{
						if (run_servers[i].server_name == m_server_name && run_servers[i].guid == myguid )
						{
							p_da_Browser = run_servers[i].cur_browse_item;
							m_opcServer = run_servers[i].opcServer;
							get_opcserver_status(myguid.toString());
							ui.toolButton->setEnabled(true);
							break;
						}
					}
					IOPCItemProperties *ItemProp = 0;
					HRESULT hr = m_opcServer->QueryInterface(IID_IOPCItemProperties, (void**)&ItemProp);
					if (SUCCEEDED(hr))
					{
						DWORD countprop = 0;
						DWORD *ids = 0;
						LPWSTR *descs = 0;
						VARTYPE *vts = 0;
						HRESULT *erhRes = 0;
						VARIANT *v = 0;
						DWORD i;

						hr = ItemProp->QueryAvailableProperties(T2W((LPTSTR)itm_data[1].utf16()), &countprop, &ids, &descs, &vts);
						if (SUCCEEDED(hr))
						{
							hr = ItemProp->GetItemProperties(T2W((LPTSTR)itm_data[1].utf16()), countprop, ids, &v, &erhRes);
							if (SUCCEEDED(hr))
							{										
								for(i=0; i<countprop; i++)
								{
									if(erhRes[i] == S_OK)
									{							
										temp_str = "";
										DWORD item_number = ids[i];
										QString item_descr = QString::fromStdWString(descs[i]);
										QStringList item_value = get_value(&v[i]);	

										ui.tableWidget_2->insertRow(0);	

										QTableWidgetItem *number_item = new QTableWidgetItem();
										number_item->setData(0,(qint64)item_number);
										ui.tableWidget_2->setItem(0, 0, number_item);

										QTableWidgetItem *descr_item = new QTableWidgetItem();
										descr_item->setData(0,item_descr);
										ui.tableWidget_2->setItem(0, 1, descr_item);

										QTableWidgetItem *value_item = new QTableWidgetItem();
										value_item->setData(0,item_value[0]);
										ui.tableWidget_2->setItem(0, 2, value_item);
									}
								}
								ui.tableWidget_2->setSortingEnabled(true);
								ui.tableWidget_2->sortItems(0);
							}			
							if (ids)
								CoTaskMemFree(ids);
							if (descs)
								CoTaskMemFree(descs);
							if (vts)
								CoTaskMemFree(vts);
							if (v)
								CoTaskMemFree(v);
							if (erhRes)
								CoTaskMemFree(erhRes);

						}
						ItemProp->Release();
					}

					break;
				}
				else
					if (dt[0] == "OPC_HDA_SERVER_NAME" && m_hda_opcServer != NULL)
					{						
						QUuid hda_myguid = (dt[2]);	
						for (int i = 0; i<hda_run_servers.count();i++)
						{
							if (hda_run_servers[i].server_name == dt[1] && hda_run_servers[i].guid == hda_myguid)	//     	
							{									  							 
								m_hda_opcServer = hda_run_servers[i].hda_opcServer;
								p_hda_Browser = hda_run_servers[i].p_hda_Browser;
								get_hda_opcserver_status(hda_myguid.toString());
								ui.toolButton->setEnabled(false);
								break;
							}
						}
						break;
					}
			}
		}
}

void my_opc::enum_network(QTreeWidgetItem *itm) // 
{
	DWORD dwResult, dwResultEnum;
	HANDLE hEnum = INVALID_HANDLE_VALUE;
	DWORD cEntries = -1;
	DWORD cbBuffer = 16384;
	QString res_name;
	
	QSplashScreen splash(QPixmap(":/png/splash.png")); 
	splash.move(QCursor::pos());
	splash.show();
	splash.showMessage("...", Qt::AlignBottom);		 

	LPNETRESOURCE lpnr = (LPNETRESOURCE) GlobalAlloc(GPTR, cbBuffer);

	if (itm)
 {
	itm->takeChildren();
	QStringList itm_data = itm->data(0,Qt::UserRole).toStringList();
	if (itm_data.size() == 8)
	{
	lpnr->dwScope = itm_data[0].toULong();
	lpnr->dwType = itm_data[1].toULong();
	lpnr->dwDisplayType = itm_data[2].toULong();
	lpnr->dwUsage = itm_data[3].toULong();
	lpnr->lpLocalName = T2W((LPTSTR)itm_data[4].utf16());
	lpnr->lpRemoteName = T2W((LPTSTR)itm_data[5].utf16());
	lpnr->lpComment = T2W((LPTSTR)itm_data[6].utf16());
	lpnr->lpProvider = T2W((LPTSTR)itm_data[7].utf16());
	}

	dwResult = WNetOpenEnum(RESOURCE_GLOBALNET, RESOURCETYPE_ANY, RESOURCEUSAGE_CONTAINER, lpnr, &hEnum);	
 }
	else
		dwResult = WNetOpenEnum(RESOURCE_GLOBALNET, RESOURCETYPE_ANY, RESOURCEUSAGE_CONTAINER, NULL, &hEnum);	      

	if (dwResult != NO_ERROR) 	
	{
		
		itm->setChildIndicatorPolicy(QTreeWidgetItem::ShowIndicator);
		GlobalFree((HGLOBAL) lpnr);		
		QString err = QString::fromUtf16(_com_error(dwResult).ErrorMessage());
		QMessageBox::warning(0, "!",": "+err);
		return;
	}
	
	LPNETRESOURCE lpnrLocal = (LPNETRESOURCE) GlobalAlloc(GPTR, cbBuffer);
	if (lpnrLocal == NULL) 
	{
	
		QMessageBox::warning(0, "!", "WnetOpenEnum   !");
		return;
	}

	do 
	{
		ZeroMemory(lpnrLocal, cbBuffer);		
		dwResultEnum = WNetEnumResource(hEnum, &cEntries, lpnrLocal, &cbBuffer);
		if (dwResultEnum == !NO_ERROR)
		{
			
				QMessageBox::warning(0, "!", "WNetEnumResource   !");
			    return;
		}

			for (DWORD i = 0; i < cEntries; i++) 
			{				
				if (lpnrLocal[i].lpRemoteName)
				res_name = QString::fromStdWString(lpnrLocal[i].lpRemoteName);
				else
					res_name = QString::fromStdWString(lpnrLocal[i].lpComment);

				QTreeWidgetItem *item;
				item  = new QTreeWidgetItem;
				item->setText(0, res_name);
				item->setChildIndicatorPolicy(QTreeWidgetItem::ShowIndicator);

				QString lpLocalName, lpRemoteName, lpComment, lpProvider, dwScope, dwType, dwDisplayType, dwUsage;

				if (lpnrLocal[i].dwScope)
					dwScope = QString::number(lpnrLocal[i].dwScope);

				if (lpnrLocal[i].dwType)
					dwType = QString::number(lpnrLocal[i].dwType);

				if (lpnrLocal[i].dwDisplayType)
					dwDisplayType = QString::number(lpnrLocal[i].dwDisplayType);

				if (lpnrLocal[i].dwUsage)
					dwUsage = QString::number(lpnrLocal[i].dwUsage);				

				if (lpnrLocal[i].lpLocalName)
					lpLocalName = QString::fromStdWString(lpnrLocal[i].lpLocalName);

				if (lpnrLocal[i].lpRemoteName)
					lpRemoteName = QString::fromStdWString(lpnrLocal[i].lpRemoteName);

				if (lpnrLocal[i].lpComment)
					lpComment = QString::fromStdWString(lpnrLocal[i].lpComment);

				if (lpnrLocal[i].lpProvider)
					lpProvider = QString::fromStdWString(lpnrLocal[i].lpProvider);	

				QStringList item_data;
				item_data<<dwScope<<dwType<<dwDisplayType<<dwUsage<<lpLocalName<<lpRemoteName<<lpComment<<lpProvider;			
				item->setData(0, Qt::UserRole, item_data);

				if (itm)
			        itm->addChild(item);
				else				
					ui.treeWidget->addTopLevelItem(item);
			}	
	}	
	while (dwResultEnum != ERROR_NO_MORE_ITEMS);
	GlobalFree((HGLOBAL) lpnrLocal);
	GlobalFree((HGLOBAL) lpnr);
	dwResult = WNetCloseEnum(hEnum);	
	if (dwResult != NO_ERROR) 
		QMessageBox::warning(0, "!","WNetCloseEnum   !");
}

void my_opc::get_OPCServerList(QTreeWidgetItem *item, CLSID catid)
{
	if (item)
	{
		QTreeWidgetItem *opc_server_type  = new QTreeWidgetItem;
		if (catid == CATID_OPCDAServer20)
		opc_server_type->setText(0,"OPC Data Access");
		else
			if ((catid == CATID_OPCHDAServer10))
				opc_server_type->setText(0,"OPC Historial Data Access");
			else
				opc_server_type->setText(0,"OPC");
		
		item->insertChild(0, opc_server_type);

		QString comp_name = item->data(0,0).toString();
		COSERVERINFO *ServerInfo = new COSERVERINFO();
		ServerInfo->pwszName = T2W((LPTSTR)comp_name.utf16());
		ServerInfo->pAuthInfo = NULL;

		if (!ui.login_lineEdit->text().isEmpty())
		{
			COAUTHIDENTITY *AuthIdentity = new COAUTHIDENTITY();
			AuthIdentity->Domain = (USHORT*)ui.domain_lineEdit->text().utf16();
			AuthIdentity->DomainLength = wcslen(ui.domain_lineEdit->text().utf16());
			AuthIdentity->User = (USHORT*)ui.login_lineEdit->text().utf16();
			AuthIdentity->UserLength = wcslen(ui.login_lineEdit->text().utf16());
			AuthIdentity->Password = (USHORT*)ui.passwords_lineEdit->text().utf16();
			AuthIdentity->PasswordLength = wcslen(ui.passwords_lineEdit->text().utf16());
			AuthIdentity->Flags = SEC_WINNT_AUTH_IDENTITY_UNICODE;				

			COAUTHINFO *AuthInfo = new COAUTHINFO();
			AuthInfo->dwAuthnSvc           = RPC_C_AUTHN_WINNT;
			AuthInfo->dwAuthzSvc           = RPC_C_AUTHZ_NONE;
			AuthInfo->pwszServerPrincName  = NULL;
			AuthInfo->dwAuthnLevel         = RPC_C_AUTHN_LEVEL_CONNECT;
			AuthInfo->dwImpersonationLevel = RPC_C_IMP_LEVEL_IMPERSONATE;
			AuthInfo->dwCapabilities = EOAC_NONE;

			AuthInfo->pAuthIdentityData = AuthIdentity;
			ServerInfo->pAuthInfo = AuthInfo;

		//Sleep(100);//     ????
		}
		
		MULTI_QI pResults;
		memset(&pResults, 0, sizeof(pResults));
		pResults.pIID = &IID_IOPCServerList;
		pResults.pItf = 0;
		pResults.hr = 0;

		HRESULT hres = CoCreateInstanceEx(CLSID_OpcServerList, 0, CLSCTX_ALL, ServerInfo, 1, &pResults);

		if (hres == S_OK)
		{			
			IOPCServerList  *pcr =(IOPCServerList*)pResults.pItf;
			IEnumGUID* enum_guid = NULL;
			hres = pcr->EnumClassesOfCategories(1, &catid, 1, &catid, &enum_guid);
			if (hres == S_OK)
			{
				GUID guid;
				ULONG count;
				LPOLESTR prg_id = 0;   
				LPOLESTR usr_type = 0;

				while (enum_guid->Next(1, &guid, &count) == S_OK && count == 1)
				{
					hres = pcr->GetClassDetails(guid, &prg_id, &usr_type);
					if (SUCCEEDED(hres))
					{
						QTreeWidgetItem *opc_server = new QTreeWidgetItem;
						opc_server->setText(0, QString::fromStdWString(prg_id));	
						QStringList item_data;
						QUuid myguid(guid);

						if (catid == CATID_OPCDAServer20)
						item_data<<"OPC_DA_SERVER_NAME"<<comp_name<<myguid.toString();   
						else
							item_data<<"OPC_HDA_SERVER_NAME"<<comp_name<<myguid.toString(); 
						
						opc_server->setData(0, Qt::UserRole, item_data);
						opc_server->setChildIndicatorPolicy(QTreeWidgetItem::ShowIndicator);
						opc_server_type->addChild(opc_server);
					}
					   else
					   {
						QString err = QString::fromUtf16(_com_error(hres).ErrorMessage());
						QMessageBox::warning(0, "!",": (GetClassDetails) "+err);
					   }
				}
				CoTaskMemFree(prg_id);
				CoTaskMemFree(usr_type);
				enum_guid->Release();   
				pcr->Release(); 
			}
			else
			{
				QString err = QString::fromUtf16(_com_error(hres).ErrorMessage());
				QMessageBox::warning(0, "!"," (EnumClassesOfCategories): "+err);
			}			
		}
		else
		{
			QString err = QString::fromUtf16(_com_error(hres).ErrorMessage());
			QMessageBox::warning(0, "!",": (CoCreateInstanceEx) "+err);
		}


		if (ServerInfo)
		{
			delete (ServerInfo);
			ServerInfo = NULL;
		}

	}	
}

bool my_opc::start_da_server(const QString &servername, const QUuid &guid)
{
	for (int i = 0; i<run_servers.count();i++)
	{
		if (run_servers[i].server_name == servername && run_servers[i].guid == guid)	//     	
		{									  							 
			m_opcServer = run_servers[i].opcServer;
			p_da_Browser = run_servers[i].cur_browse_item;
			return true;
		}
	}
	
	COSERVERINFO *ServerInfo = new COSERVERINFO();
	ServerInfo->pwszName = T2W((LPTSTR)servername.utf16());
	ServerInfo->pAuthInfo = NULL;

	if (!ui.login_lineEdit->text().isEmpty())
	{		
		COAUTHIDENTITY *AuthIdentity = new COAUTHIDENTITY();
		AuthIdentity->Domain = (USHORT*)ui.domain_lineEdit->text().utf16();
		AuthIdentity->DomainLength = wcslen(ui.domain_lineEdit->text().utf16());
		AuthIdentity->User = (USHORT*)ui.login_lineEdit->text().utf16();
		AuthIdentity->UserLength = wcslen(ui.login_lineEdit->text().utf16());
		AuthIdentity->Password = (USHORT*)ui.passwords_lineEdit->text().utf16();
		AuthIdentity->PasswordLength = wcslen(ui.passwords_lineEdit->text().utf16());
		AuthIdentity->Flags = SEC_WINNT_AUTH_IDENTITY_UNICODE;				
		
		COAUTHINFO *AuthInfo = new COAUTHINFO();
		AuthInfo->dwAuthnSvc           = RPC_C_AUTHN_WINNT;
		AuthInfo->dwAuthzSvc           = RPC_C_AUTHZ_NONE;
		AuthInfo->pwszServerPrincName  = NULL;
		AuthInfo->dwAuthnLevel         = RPC_C_AUTHN_LEVEL_CONNECT;
		AuthInfo->dwImpersonationLevel = RPC_C_IMP_LEVEL_IMPERSONATE;
		AuthInfo->dwCapabilities = EOAC_NONE;
		
		AuthInfo->pAuthIdentityData = AuthIdentity;
		ServerInfo->pAuthInfo = AuthInfo;
		//Sleep(100); //     ????
	}

	MULTI_QI queue [1];
	queue [0].pIID = &IID_IOPCServer;
	queue [0].pItf = NULL;
	queue [0].hr   = 0;

	HRESULT hres = CoCreateInstanceEx(guid, NULL, CLSCTX_ALL, ServerInfo, 1, queue); // 
	if (hres == S_OK)
	{
		m_opcServer = (IOPCServer *) queue[0].pItf;	
		hres = m_opcServer->QueryInterface(IID_IOPCBrowseServerAddressSpace, (void**)&p_da_Browser);
		if  (SUCCEEDED(hres))
		{					
			mysrv running_srv;	//    											
			running_srv.server_name = servername;
			running_srv.opcServer = m_opcServer;
			running_srv.guid = guid;
			running_srv.cur_browse_item = p_da_Browser;
			run_servers.append(running_srv);
		}
	}
	else
	{
		QString err = QString::fromUtf16(_com_error(hres).ErrorMessage());
		QMessageBox::warning(0, "!",servername+" - "+err);

		if (ServerInfo)
		{
			delete (ServerInfo);
			ServerInfo = NULL;
		}

		return false;
	}
				
	if (ServerInfo)
	{
	delete (ServerInfo);
	ServerInfo = NULL;
	}
	return true;
}

void my_opc::add_items_da_server(const QString &servername, const QUuid &guid, const QString &itemID)
{	
	OPCHANDLE phServerGroup = 0;
	IOPCItemMgt *pItemMgt = NULL;

	DWORD updateRate = 1000;
	HRESULT hr;

	if (!m_opcServer)
		return;

	hr = m_opcServer->GetGroupByName(_T("MyGroup"), __uuidof(IOPCItemMgt), (IUnknown**)&pItemMgt);
	if (!SUCCEEDED(hr))					
		hr = m_opcServer->AddGroup(_T("MyGroup"), true, updateRate, 1, NULL, NULL, 0, &phServerGroup, &updateRate, __uuidof(IOPCItemMgt), (IUnknown**)&pItemMgt);				
	if (SUCCEEDED(hr))
	{			        					
		DWORD dwCount = 1;		
		tagOPCITEMDEF* pItems = (tagOPCITEMDEF*)CoTaskMemAlloc(dwCount*sizeof(tagOPCITEMDEF));
		tagOPCITEMRESULT* pResults = NULL;
		HRESULT* pErrors = NULL;
		pItems[0].szItemID = bstr_t(itemID.utf16()); 
		pItems[0].szAccessPath =  _T("");
		pItems[0].bActive = TRUE;
		pItems[0].hClient = 0;
		pItems[0].vtRequestedDataType = VT_EMPTY;
		pItems[0].dwBlobSize = 0;
		pItems[0].pBlob = NULL;

		hr = pItemMgt->AddItems(1, pItems, &pResults, &pErrors);
		if (SUCCEEDED(hr) && hr != S_FALSE)
		{						 																		
			IOPCSyncIO * pSyncIO = NULL;
			IID IID_IOPCSYNCIO =__uuidof(IOPCSyncIO);
			hr=pItemMgt->QueryInterface(IID_IOPCSYNCIO,(void**)&pSyncIO);

			myhwnd hw;
			hw.srv_results = &pResults->hServer;
			hw.syncio = pSyncIO;
			hw.ItemMgt = pItemMgt;
			hw.itemID = itemID;

			hw.server_name = servername;
			hw.myId = id;	
			hw.add_grp_handle = phServerGroup;
			hw.srv_guid = guid;
			hwnds.append(hw);
			id++;

			if (!update_timer->isActive())
				update_timer->start(1000);									
		}
		else
		{
			LPWSTR lpError;
			m_opcServer->GetErrorString(*pErrors,2,&lpError);						
			QString err = QString::fromUtf16(lpError);
			if (err.isEmpty())
				err = QString::fromUtf16(_com_error(hr).ErrorMessage());
			QMessageBox::warning(0, "!","    : "+err);			
		}

		CoTaskMemFree(pErrors);
		CoTaskMemFree(pItems);		
	}
	else
	{
		QString err = QString::fromUtf16(_com_error(hr).ErrorMessage());
		QMessageBox::warning(0, "!","    : "+err);
	}

	if (pItemMgt)
		pItemMgt->Release();
}
