#ifndef MY_OPC_H
#define MY_OPC_H

#include <QtGui/QMainWindow>
#include "ui_my_opc.h"
#include <QWindowsXPStyle>
#include "qt_windows.h"
#include <QMessageBox>
#include <QSplashScreen>
#include "atlcomcli.h"
#include <QUuid>
#include <QMenu>
#include <QFile>
#include <QDesktopWidget>
#include <QDesktopServices>
#include <QVector>
#include <QTimer>
#include <QCalendarWidget>
#include <QInputDialog>
#include <QTextDocument>
#include <QTextDocumentWriter>
#include <QPrinter>
#include <QPrintPreviewDialog>
#include <QTextTable>
#include <QFileDialog>
#include <QVarLengthArray>
#include <QXmlStreamWriter>
//#include "Debug/opcproxy.tlh"
#include "c:\proekts\my_opc\my_opc\inc\opcda.h"
#include "c:\proekts\my_opc\my_opc\inc\opccomn.h"
#include "c:\proekts\my_opc\my_opc\inc\OpcEnum.h"
#include "c:\proekts\my_opc\my_opc\inc\opchda.h"
#include "c:\proekts\my_opc\my_opc\inc\OpcHda_Error.h"

//#import "c:\\test_dll\\opcproxy.dll"
#pragma comment(lib, "mpr.lib")

//using namespace OPCDA;
#define NEXT_COUNT 100

typedef struct srv
{
	CComPtr<IOPCServer> opcServer;
	IOPCBrowseServerAddressSpace *cur_browse_item;
	QUuid guid;
	QString server_name;
}   mysrv;

typedef struct srv_handls
{	
	OPCHANDLE *srv_results;
	IOPCSyncIO *syncio;
	IOPCItemMgt *ItemMgt;
	QString itemID;
	OPCHANDLE add_grp_handle;
	QUuid srv_guid;
	QString server_name;
	int myId;
}   myhwnd;

typedef struct hda_srv
{
	CComPtr<IOPCHDA_Server> hda_opcServer;
	IOPCHDA_Browser *p_hda_Browser;
	QUuid guid;
	QString server_name;
}   hda_mysrv;


typedef struct file_data
{	
	QString server_name;
	QUuid guid;
	QString itemID;
}   saved_file_data;

class my_opc : public QMainWindow
{
	Q_OBJECT

public:
	my_opc(QWidget *parent = 0, Qt::WFlags flags = 0);
	void closeEvent(QCloseEvent *event);
	QTextDocument* print_opc_info(QTableWidget *tbl);
	void resizeEvent(QResizeEvent *event);
	void setDockSize(QDockWidget* dock, int setWidth,int setHeight);

	~my_opc();

private:
	Ui::my_opcClass ui;
	void DisplayChildren(QTreeWidgetItem *current);
	void Display_HDA_Children(QTreeWidgetItem *current);
	CComPtr<IOPCServer> m_opcServer;
	CComPtr<IOPCHDA_Server> m_hda_opcServer;

	int id;

	QVector<mysrv> run_servers;
	QTimer *update_timer;
	QVector<myhwnd>hwnds;
	QVector<hda_mysrv> hda_run_servers;
	QVector<saved_file_data> my_file_data;

	void enum_network(QTreeWidgetItem *item);
	void get_OPCServerList(QTreeWidgetItem *item, CLSID catid);
	bool start_da_server(const QString &servername, const QUuid &guid);
	void add_items_da_server(const QString &servername, const QUuid &guid, const QString &itemID);
	IOPCBrowseServerAddressSpace* p_da_Browser;
	IOPCHDA_Browser *p_hda_Browser;
	void get_opcserver_status(const QString &guid);
	void get_hda_opcserver_status(const QString &guid);
	QString get_quality(ushort usQuality);
	QString get_hda_quality(DWORD qualit);
	OPCHDA_TIME getstarttime();
	OPCHDA_TIME getendtime();
	QStringList get_value (VARIANT *my_tag);
	QString	SystemTime_to_QString(SYSTEMTIME st);
	QString get_err(const HRESULT &pErrors);
	
	private slots:
		void onitemExpanded(QTreeWidgetItem*);
		void on_toolButton_clicked();
		void on_get_hda_value_Button_clicked();
		void indexChanged(QTreeWidgetItem *, QTreeWidgetItem *);
		void on_tableWidget_customContextMenuRequested(QPoint);
		void on_tableWidget_3_customContextMenuRequested(QPoint);
		void on_treeWidget_customContextMenuRequested(QPoint);
		void stop_start_browse_da_values();
		void save_to_html(QPrinter* printer);
		void save_hda_to_html(QPrinter* printer);
		void print_to_html();
		void print_hda_to_html();
		void save_to_file();
		void load_from_file();
		void clear_tableWidget();
		void clear_all_tableWidget();
		void clear_hda_tableWidget();
		void clear_all_hda_tableWidget();
		void update_opc_items();
		void do_ReadRawButton();
		void do_ReadAtTimeButton();
		void do_ReadAttributeButton();
		void do_ReadProcessedButton();
		void ip_connect();
		void redraw();
		void returnToOldMaxMinSizes();


};


#endif // MY_OPC_H
